// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

var open = new Object();
var expanders = new Object();
var collapseableDivs = new Object();
var httpConnectors = new Object();
var preferenceBox;
var LAST_LEVEL = 3;
var ROOTID_ALL = "all";
var TYPE_UNUSED = "Unused";
var UNASSIGNED_NODEGROUP ="Unassigned";//just as a nicety, we don't want to choose the Unassigned node group by default if we don't have to.
var TYPE_ROOT = "root";
var TYPE_PARTITION = "p";
var DEFAULT_LOW_COLOR = "00C040";
var DEFAULT_HIGH_COLOR = "FF0000";
var DEFAULT_WIDTH = 4;
var DEFAULT_RTBASE = 2000;
var STATTYPE_CURRENT = "current";
var STATTYPE_CUMULATIVE = "cumulative";
var MS_UNITS = "ms"; //I spoke with the translation guys about this, and since it's abbreviated, it does not need to be translated
var STATTYPE_LIST = [
	new SelectOption(STATLABEL_CURRENT, STATTYPE_CURRENT),
	new SelectOption(STATLABEL_CUMULATIVE, STATTYPE_CUMULATIVE)
];

var newwin;
function debug(msg){
	return; //DISABLED
	if (!newwin)
		newwin = window.parent.open();
	if (typeof(msg) != "string")
		newwin.document.writeln("[" + msg.toString() + "]<BR>");
	else
		newwin.document.writeln(msg + "<br>");
}

function getPlusMinus(box){
	if (open[box])
		return minus;
	else
		return plus;			
}

function toggle(id){
	if (open[id]){
		var div = document.getElementById(id);
		if (div)
			div.style.display="none";
		var expander = document.getElementById(id + "_Exp");
		if (expander)
			expander.src = plus;
		open[id] = false;
	} else {
		var div = document.getElementById(id);
		if (div)
			div.style.display="block";
		var expander = document.getElementById(id + "_Exp");
		if (expander)
			expander.src = minus;
		open[id] = true;
	}
}

//changes the type of the preferences form
function changeType(levelNum){
	debug("changeType: " + levelNum);
	if (!preferenceBox)
		return;
	var table = document.getElementById(preferenceBox.tableId);
	var tableBody = table.getElementsByTagName("TBODY")[0];
	if (!tableBody){
		tableBody = document.createElement("TBODY");
		table.appendChild(tableBody);
	}	
	var childNodes = tableBody.getElementsByTagName("TR"); // each level is effectively a TR, so this works nicely.
		
	//get the types for the next level after levelNum
	var name = "entry[" + levelNum + "].type";
	var selectBox = document.TreemapPreferenceForm[name];
	var selectedOption = selectBox.options[selectBox.selectedIndex];
	var selectedType = selectedOption.value;
	debug("selectedType: " + selectedType);
	var level = preferenceBox.getLevel(levelNum);

	updateChildRoots(levelNum-1); //get new roots for this level (update the child roots for our parent level)
	if (selectedType != TYPE_PARTITION)
		preferenceBox.removePartitionRow(childNodes, tableBody);
	if (selectedType == TYPE_UNUSED){
		preferenceBox.getLevel(levelNum-1).makeLeafNode();
		disableLevel(levelNum);		
		removeChildLevels(levelNum);
	} else {
		handleChangeToNonUnusedType(levelNum, selectedType);
	}
	
	if (selectedType == TYPE_PARTITION){
		//need to add two additional fields in the next row (response time reference point (text field) and metric type (drop down box)
		tr = document.createElement("TR");		
		tr.appendChild(document.createElement("TD"));//blank table data
		
		td = document.createElement("TD");
		td.setAttribute("colSpan", 4);
		td.appendChild(document.createTextNode(STATTYPE_TEXT + ": "));
		var stattypeBox = createSelectBox(levelNum, "stattype", STATTYPE_LIST, true, "", STATTYPE_CURRENT);
		stattypeBox.style.marginRight="17px";
		td.appendChild(stattypeBox);
		tr.appendChild(td);
		
		var rtBaseBox = document.createElement("input");
		rtBaseBox.setAttribute("type", "text");
		rtBaseBox.setAttribute("size", "10");
		rtBaseBox.setAttribute("name", "entry[" + levelNum + "].rtBase");
		rtBaseBox.setAttribute("value", DEFAULT_RTBASE);
		td.appendChild(document.createTextNode(RTBASE_TEXT + ": "));
		td.appendChild(rtBaseBox);			
		td.appendChild(document.createTextNode(MS_UNITS));
		tr.appendChild(td);
		
		tableBody.appendChild(tr);
	}
}

	//a non-UNUSED type was selected, so update the next level's types, set the type to UNUSED, root to ROOTID_ALL, disable this new row,
	//and remove all subsequent levels	
function handleChangeToNonUnusedType(levelNum, selectedType){
		debug("handleChangeToNonUnusedType levelNum: "+ levelNum);
		for (var i = 0; i < levelNum; i++)
			preferenceBox.getLevel(i).makeNonLeafNode(); //nothing above this node can be a leaf.
			
		preferenceBox.removeLevel(levelNum + 1);//remove all levels from here down (one will be re-added)

		enableLevel(levelNum);
		var subTypes = getNextLevelTypes(levelNum, selectedType);
		
		var level = preferenceBox.getLevel(levelNum);
		level.makeLeafNode();
			
		if (subTypes && subTypes.length > 0 && levelNum < LAST_LEVEL){
			//create a level for this sublevel and add it
			//function Level(types, type, roots, root, colors, color, color2, width, levelNumber){
			var roots = new Array();
			roots.push(new SelectOption(LABEL_ALL, ROOTID_ALL));
			var subLevel = new Level(subTypes, TYPE_UNUSED, roots, ROOTID_ALL, preferenceBox.colors, preferenceBox.colors[levelNum+1], null, DEFAULT_WIDTH, levelNum+1);
			preferenceBox.addLevel(subLevel);	
			disableLevel(subLevel.levelNumber); //disable this until they choose a TYPE			
		}	
}

//a root changed at level: levelNum.  We have to adjust the roots below it accordingly.  The type has remained the same, however.
//if levelNum is less than 0, we use parentType = TYPE_ROOT
function updateChildRoots(levelNum){
        if (!preferenceBox)
                return;
        if (levelNum < 0)
        		levelNum = -1; //so we can support any negative integer as meaning parentType = TYPE_ROOT
        var updateLevelNum = levelNum+1;
        if (updateLevelNum >= preferenceBox.numLevels)
                return;

        //temporarily disable the levels from here down.
        for (var i = updateLevelNum; i < preferenceBox.numLevels; i++){
                disableLevel(i);
        }

        //get the types for the next level after levelNum
        var name = "entry[" + updateLevelNum + "].type";
        var rootsname = "entry[" + updateLevelNum + "].root";
        var selectBox = document.TreemapPreferenceForm[name];
        var rootSelectBox = document.TreemapPreferenceForm[rootsname];
        var options = selectBox.options;
        var selectedOption = options[selectBox.selectedIndex];
        var selectedType = selectedOption.value;
        var level, parentType, parentId;

        if (updateLevelNum > 0){
	        level = preferenceBox.getLevel(levelNum);
	        parentType = level.type;
	        parentId = level.root;
        } else { //this is a change in the root level
        	  parentType = TYPE_ROOT;
        }
        rootList = getRootList(i, rootSelectBox, selectedType, parentType, parentId);
        rootSelectBox.options.length = 0; //clear the list
		
		  if (!rootList || rootList.length == 0){
		  		preferenceBox.removeLevel(updateLevelNum);
		  } else {		  	   						
	        //figure out which root to have selected.
	        var selectedRoot = pickARoot(rootList);
	        	
	        //populate the select box with the new list
			  populateSelectBoxWithRoots(rootSelectBox, rootList, selectedRoot);
			
			  var updateLevel = preferenceBox.getLevel(updateLevelNum);
	        if (updateLevel.type != TYPE_UNUSED)
	        		enableLevel(updateLevelNum);
	        if ( (updateLevelNum+1) < (preferenceBox.numLevels))//if there is a level after updateLevel, let's update its roots
	                updateChildRoots(updateLevelNum);
		  }
}

function populateSelectBoxWithRoots(rootSelectBox, rootList, selectedRoot){
    var selected = false;
    for (var a = 0; a < rootList.length; a++){
        selected = (rootList[a].value == selectedRoot);
        rootSelectBox.options[rootSelectBox.options.length] = new Option(rootList[a].text, rootList[a].value, selected, selected);
    }	
}

function pickARoot(rootList){
	var ret = null;
	for (var i = 0; i < rootList.length; i++){
		ret = rootList[i];
		if (ret != ROOTID_ALL && (rootList.length > 2 && ret != UNASSIGNED_NODEGROUP) ) //if there are more entries besides [Unassigned, ROOTID_ALL], don't choose Unassigned.  This is most likely a nodegroup, but if it isn't - we can still decide not to pick Unassigned as our random pick.
			break;
	}
	return ret;
}

function pickType(typeList){
	var ret = null;
	for (var i = 0; i < typeList.length; i++){
		ret = typeList[i];
		if (ret != TYPE_UNUSED)
			break;
	}
	return ret;
}

function getRootList(levelNum, selectBox, selectedType, parentType, parentId){
	debug("getRootList");
	var httpConn = getHTTPConnector("rootData");
	
	var sUri = LEVEL_GETTER_URL + "?action=getRoots&type=" + selectedType;
	if (parentType)
		sUri += "&parentType=" + parentType;
	if (parentId)
		sUri +="&parentId=" + parentId;
	var roots = new Array();
	//roots.push(new SelectOption(LABEL_ALL, ROOTID_ALL));
	try
	{
		//false means "Synchronous"
		httpConn.open('GET', sUri, false);
		httpConn.send(null);
		dataArrived();
	}
	catch(e)
	{
		alert('exception getting root list: ' + e.message);
		//something bad happened with the connection attempt, catch the exception
	}
	
	debug("roots: " + roots.toString());
	return roots;

	//nested function (so it has access to "types")
	function dataArrived(){
		var httpConn = httpConnectors["rootData"];
		
		if(httpConn && httpConn.readyState == 4){
			//if we just finished receiving a response
			var xmlDoc = httpConn.responseXML;
			var docElem = xmlDoc.documentElement;		
	
			if (docElem){
				var childNodes = docElem.getElementsByTagName("Root");
				var elem, id, label;		
				for (var i = 0; i < childNodes.length; i++){
					elem = childNodes.item(i);							
					id = elem.getAttribute("id");
					label = elem.getAttribute("label");
					roots.push(new SelectOption(label, id));
					debug("ROOT childNode: " + id);
				}			
			}
		}
	};
	
}

function removeChildLevels(parentLevelNum){
	//remove all levels below parentLevelNum.
	for (var i = parentLevelNum + 1; i <= preferenceBox.numLevels; i++)
		preferenceBox.removeLevel(i);	
}
//disable all items on this level EXCEPT the types box.
//also, set the "roots" to "none"
function disableLevel(levelNum){
	debug("disabling level: " + levelNum);
	setDropDownBoxValue(document.TreemapPreferenceForm['entry[' + levelNum + '].root'], ROOTID_ALL);
	document.TreemapPreferenceForm['entry[' + levelNum + '].root'].disabled = true;
	document.TreemapPreferenceForm['entry[' + levelNum + '].color'].disabled = true;	
	var partMetric = document.TreemapPreferenceForm['entry[' + levelNum + '].partMetric'];
	if (partMetric)
		partMetric.disabled = true;
	var rtBase = document.TreemapPreferenceForm['entry[' + levelNum + '].rtBase'];
	if (rtBase)
		rtBase = true;	
	var color2 = document.TreemapPreferenceForm['entry[' + levelNum + '].color2'];
	if (color2)
		color2.disabled = true;
	var width = document.TreemapPreferenceForm['entry[' + levelNum + '].width'];
	if (width)
		width.disabled = true;		
}

//if the dropdown box (box) contains an option with value newVal, set it to selected.  if no such
//value exists in the list:
//if ROOTID_ALL exists, it is selected.
//otherwise, if TYPE_UNUSED exists, it is selected
//otherwise, nothing is selected (selectedIndex set to -1)
function setDropDownBoxValue(box, newVal){
	if (!box)
		return;
	var options = box.options;
	if (!options)
		return;
	var selIndex = -1, noneIndex = -1, unusedIndex=-1;
	for (var i = 0; i < options.length; i++){
		if (options[i].value == newVal){
			selIndex = i;
			break;	
		} else if (options[i].value == ROOTID_ALL)
			noneIndex = i;
		else if (options[i].value == TYPE_UNUSED)
			unusedIndex = i;
	}
	if (selIndex == -1)
		selIndex = noneIndex;
	if (selIndex == -1)
		selIndex = unusedIndex;
		
	box.selectedIndex = selIndex;
}

//enable all items on this level EXCEPT the types box.
function enableLevel(levelNum){
	document.TreemapPreferenceForm['entry[' + levelNum + '].root'].disabled = false;
	document.TreemapPreferenceForm['entry[' + levelNum + '].color'].disabled = false;
	var partMetric = document.TreemapPreferenceForm['entry[' + levelNum + '].partMetric'];
	if (partMetric)
		partMetric.disabled = false;
	var rtBase = document.TreemapPreferenceForm['entry[' + levelNum + '].rtBase'];
	if (rtBase)
		rtBase = false;
	var color2 = document.TreemapPreferenceForm['entry[' + levelNum + '].color2'];
	if (color2)
		color2.disabled = false;
	var width = document.TreemapPreferenceForm['entry[' + levelNum + '].width'];
	if (width)
		width.disabled = false;		
}

function PreferenceBox(tableId, formName){
	this.tableId = tableId;
	this.formName = formName;
	this.numLevels = 0;
	setInitialPreferenceBoxState(this);

	this.getLevel = function(levelNum){
		if (levelNum >= this.numLevels)
			return null;
		return getLevelFromForm(levelNum, this);	
	};

	this.addLevel = function(level){
		this.numLevels++;
		var isLeafLevel = false;
		if (level.levelNumber == this.numLevels - 1){ //if this is added onto the end...
			isLeafLevel = true;
		}
		
		var table = document.getElementById(this.tableId);
		level.display(table, isLeafLevel);
		
	};
	
	//removes levels at levelNumber and HIGHER
	this.removeLevel = function(levelNumber){
		if (levelNumber > (this.numLevels - 1) ){
			return;
		}
			
		var table = document.getElementById(tableId).getElementsByTagName("TBODY")[0];
		var child;
		var childNodes = table.getElementsByTagName("TR"); // each level is effectively a TR, so this works nicely.
		this.removePartitionRow(childNodes, table);
		var stoppingNumber = levelNumber;
		if (this.hasPartitionRowBefore(levelNumber))
			stoppingNumber++;
		for (var i = childNodes.length-1; i > stoppingNumber; i-- ){ //number of the TR tag is one more than the level number
			child = childNodes.item(i);
			table.removeChild(child);
			this.numLevels--;
		}		
	};
	
	this.hasPartitionRowBefore = function(levelNum){
		var level;
		for (var i = 0; i < levelNum; i++){
				level = this.getLevel(i);
				if (level.type == TYPE_PARTITION)
					return true;					
		}	
		return false;
	}
	
	this.removePartitionRow = function(childNodes, table){
		if (childNodes.length > (this.numLevels + 1))
			table.removeChild(childNodes[childNodes.length - 1]);		
	};
	
}

function Level(types, type, roots, root, colors, color, color2, width, levelNumber){
	
debug("LEVEL: " + levelNumber);
debug("type: " + type);
debug("types: " + types);
debug("");
debug("root: " + root);
debug("roots: " + roots);
debug("");
debug("color: " + color);
debug("color2: " + color2);
debug("colors: " + colors);
debug("");
debug("width:" + width);
debug("<br><br>");

	this.levelNumber = levelNumber;
	this.types = types;
	this.type = type;
	this.roots = roots;
	this.root = root;
	this.color = color;
	this.colors = colors;
	this.color2=color2;
	this.width = width;

	this.display = displayPrefLevel;
	this.makeNonLeafNode = function(){
		debug("makenonleafnode levelNum: " + this.levelNumber);
		var form = document.TreemapPreferenceForm;
		dumpFormContents(form);
		//have to remove the second colors box, insert a width box in its place
		var color2Box = form["entry[" + this.levelNumber + "].color2"];
		if (!color2Box)
			return; // this means it is already not a leaf node.
		var par = color2Box.parentNode;
		var widthBox = document.createElement("input");
		widthBox.setAttribute("type", "text");
		widthBox.setAttribute("size", "2");
		widthBox.setAttribute("name", "entry[" + this.levelNumber + "].width");
		widthBox.setAttribute("value", DEFAULT_WIDTH);
		
		par.replaceChild(widthBox, color2Box);		
		form[widthBox.name] = widthBox; //this doesn't get set automatically for some reason.
	};
	
	this.makeLeafNode = function(){
		debug("make leaf node levelNum: " + this.levelNumber);
		var form = document.TreemapPreferenceForm;
		dumpFormContents(form);
		var widthBox = form['entry['+this.levelNumber+'].width'];
		if (!widthBox)
			return; //already a leaf node
		for (var prop in widthBox)
			debug("\t" + prop + ": " + widthBox[prop]);
		
		var par = widthBox.parentNode;
		var colorBox = form["entry[" + this.levelNumber + "].color"];
		setDropDownBoxValue(colorBox, DEFAULT_LOW_COLOR);
		var color2Box = createColorSelectBox(this.levelNumber, "color2", this.colors, DEFAULT_HIGH_COLOR);
		par.replaceChild(color2Box, widthBox);
		form[color2Box.name] = color2Box; //this doesn't get set automatically for some reason.
	};
}

function displayPrefLevel(table, isLeafLevel){
	var tableBody = table.getElementsByTagName("TBODY")[0];
	if (!tableBody){
		tableBody = document.createElement("TBODY");
		table.appendChild(tableBody);
	}
	
	//add table row		
	var tr = document.createElement("TR");
	var td = document.createElement("TD");
       td.style.whiteSpace = "nowrap";
	td.appendChild(document.createTextNode(LEVELLABELS[this.levelNumber]));
	tr.appendChild(td);

	//type
	td = document.createElement("TD");
	var typesBox = createSelectBox(this.levelNumber, "type", this.types, true, "changeType(" + this.levelNumber + ")", TYPE_UNUSED);
	td.appendChild(typesBox);
	tr.appendChild(td);
			
	//root name
	td = document.createElement("TD");
	var rootBox = createSelectBox(this.levelNumber, "root", this.roots, false, "updateChildRoots(" + this.levelNumber + ")", ROOTID_ALL);
	td.appendChild(rootBox);
	tr.appendChild(td);

	//color		
	td = document.createElement("TD");
	var colorBox = createSelectBox(this.levelNumber, "color", this.colors, false, "", DEFAULT_LOW_COLOR, true);
	td.appendChild(colorBox);
	if (isLeafLevel){
		td.setAttribute("colspan", "2");
	}
		tr.appendChild(td);
			
	if (isLeafLevel){
		td = document.createElement("TD");
		var colorBox = createSelectBox(this.levelNumber, "color2", this.colors, false, "", DEFAULT_HIGH_COLOR, true);
		td.appendChild(colorBox);
		tr.appendChild(td);	
	}
	
	//treemap border width
	if (!isLeafLevel){
		td = document.createElement("TD");
		td.setAttribute("class", "prefstext");
		var widthBox = document.createElement("input");
		widthBox.setAttribute("type", "text");
		widthBox.setAttribute("size", "2");
		widthBox.setAttribute("name", "entry[" + this.levelNumber + "].width");
		widthBox.setAttribute("value", DEFAULT_WIDTH);
		td.appendChild(widthBox);			
		td.appendChild(document.createTextNode(PIXELS));
		tr.appendChild(td);
	}
	
	//add it in the according place in the table
	if (isLeafLevel){
		debug('leaf level, appending child');
		tableBody.appendChild(tr);
	} else {
		var kids = tr.childNodes;
		for (var aa = 0; aa < kids.length; aa++){
			debug("name: " + kids.item(aa).nodeName);	
		}
		addNonLeafLevel(tr, this, tableBody);
	}
	
	if (this.type == TYPE_PARTITION){
	//need to add two additional fields in the next row (response time reference point (text field) and metric type (drop down box)
		tr = document.createElement("TR");		
		tr.appendChild(document.createElement("TD"));//blank table data
		
		td = document.createElement("TD");
		var stattypeBox = createSelectBox(this.levelNumber, "stattype", STATTYPE_LIST, true, "", STATTYPE_CURRENT);
		td.appendChild(stattypeBox);
		tr.appendChild(td);
		stattypebox.style.marginWidthRight="17px";
		
		td = document.createElement("TD");
		var rtBaseBox = document.createElement("input");
		rtBaseBox.setAttribute("colspan", 2);
		rtBaseBox.setAttribute("type", "text");
		rtBaseBox.setAttribute("size", "10");
		rtBaseBox.setAttribute("name", "entry[" + this.levelNumber + "].rtBase");
		rtBaseBox.setAttribute("value", DEFAULT_RTBASE);
		td.appendChild(rtBaseBox);			
		td.appendChild(document.createTextNode(MS_UNITS));
		tr.appendChild(td);
		
		tr.appendChild(document.createElement("TD"));
		tableBody.appendChild(tr);
	}
/*
	    var childNodes = tableBody.getElementsByTagName("TR"); //starts with index 0 = header, then goes index 1 = level 1, index 2 = level 2, etc.
	    for (var b = 0; b < childNodes.length; b++)
	            debug(childNodes[b].nodeName);
	    var childAfter = childNodes.item(this.levelNumber); //insert before the node that's currently in its place
	 	 debug('not leaf level, adding child before: ' + childAfter);
	    debug(tr);
	    tableBody.insertBefore(tr, childAfter);
*/
	
}


function addNonLeafLevel(tr, level, tableBody){
	debug('addNonLeafLevel levelNumber: ' + level.levelNumber);
	var childNodes = tableBody.getElementsByTagName("TR"); //starts with index 0 = header, then goes index 1 = level 1, index 2 = level 2, etc.
	var holder = new Array(childNodes.length - level.levelNumber - 1);
	holder.push(level);
	for (var i = level.levelNumber; i < childNodes.length; i++){
		tmpLevel = preferenceBox.getLevel(i);
		tmpLevel.levelNumber++;
		holder.push(tmpLevel);
		preferenceBox.removeLevel(i);
	}

	//now we have a list with the new level followed by all the old levels from levelNumber down....add them all back in
	for (var a = 0; a < holder.length; a++){
		alert('adding back level: ' + holder[a].levelNumber);
		preferenceBox.addLevel(holder[a]);		//this ends up recursing, but this time they will each be leafNodes
	}

}


function getHTTPConnector(connID, callback)
{
	var xmlhttp;
	if(window.ActiveXObject)
	{
		xmlhttp = new ActiveXObject('MSXML2.XMLHTTP');
	}
	else
	{
		xmlhttp = new XMLHttpRequest();
	}
	if (xmlhttp && callback)
		xmlhttp.onreadystatechange = callback;
	if (connID)
		httpConnectors[connID] = xmlhttp;
	return xmlhttp;
}

//returns an array of all the valid types for the next level
function getNextLevelTypes(levelNum, parentType){
	debug("getNextLevelTypes(" + levelNum + ", " + parentType + ")");
	var nextLevelNumber = levelNum + 1;
	if (nextLevelNumber > LAST_LEVEL)
		return null;
		
	var types = new Array();
	//types.push(new SelectOption(TYPE_UNUSED, TYPE_UNUSED));
	
	var httpConn = getHTTPConnector("levelData");
	
	var sUri = LEVEL_GETTER_URL + "?parent=" + parentType;
	try
	{
		//false means "Synchronous"
		httpConn.open('GET', sUri, false);
		httpConn.send(null);
		dataArrived();
	}
	catch(e)
	{
		alert('exception: ' + e.message);
		//something bad happened with the connection attempt, catch the exception
	}
	
	debug("TYPES: " + types.toString());
	return types;

	//nested function (so it has access to "types")
	function dataArrived(){
		var httpConn = httpConnectors["levelData"];
		
		if(httpConn && httpConn.readyState == 4){
			//if we just finished receiving a response
			var xmlDoc = httpConn.responseXML;
			var docElem = xmlDoc.documentElement;		
	
			if (docElem){
				var childNodes = docElem.getElementsByTagName("Type");
				var elem, name, display;		
				for (var i = 0; i < childNodes.length; i++){
					elem = childNodes.item(i);							
					name = elem.getAttribute("name");
					display = elem.getAttribute("display");
					types.push(new SelectOption(display, name));
					debug("TYPE childNode: "+ name);
				}			
			}
		}
	};
}

function createSelectBox(levelNumber, columnName, values, enabled, onChange, selected, isColor){
	var span = document.createElement("SPAN");
	var disabledText = "";
	if (!enabled)
		disabledText = "DISABLED";
	var styles = (isColor) ? ' style="width:60px;" ' : '';
	var selectBegin = '<SELECT size="1" '+ styles + disabledText +' onChange="' + onChange + '" name="entry[' + levelNumber + '].' + columnName + '">';
	var option;
	var defaultselected;
	var value;
	var options = "";
	var option;
	
	for (var i = 0; values && (i < values.length); i++){
		value = values[i];
		debug("VALUE: " + value);
		option = '<OPTION value="' + value.value + '"';
		if (value.value == selected)
			option += " SELECTED ";
		if (isColor)
			option += ' style="background-color:#' + value.value + '" ';
		option += '>' + value.text + '</OPTION>';
		options += option;			
	}
	debug("created selectbox, options: " + options);
	
	var selectEnd = "</SELECT>";
	span.innerHTML = selectBegin + options + selectEnd;
	return span;
}

function createColorSelectBox(levelNumber, columnName, values, selected){
	return createSelectBox(levelNumber, columnName, values, true, null, selected, true);
}

function setInitialPreferenceBoxState(prefBox){
                var form = document[prefBox.formName];
                if (!form)
                        return;

                var i, level;
                dumpFormContents(form);
                for (i = 0; form['entry['+i+'].type'] != null; i++){
                        debug("level: " + i + " was NOT null.");
                        prefBox.numLevels++;
                        level = getLevelFromForm(i, prefBox);
                        if (i == 0)
                                prefBox.colors = level.colors;
                        if (level.type == TYPE_UNUSED)
                                disableLevel(level.levelNumber);
                }
                debug("level: " + i + " was null.");
}

function getLevelFromForm(levelNum, prefBox){
	debug("getLevelFromForm level: " + levelNum);
	var form = document[prefBox.formName];
	if (!form) return;

	dumpFormContents(form);
	
	var level, types, type, roots, root, colors, color, color2, width;
	types = getOptionsFromSelectBox(form['entry['+levelNum+'].type']);
	type = getSelectedValueFromSelectBox(form['entry['+levelNum+'].type']);
	roots = getOptionsFromSelectBox(form['entry['+levelNum+'].root']);
	root = getSelectedValueFromSelectBox(form['entry['+levelNum+'].root']);
	colors = getOptionsFromSelectBox(form['entry['+levelNum+'].color']);
	color = getSelectedValueFromSelectBox(form['entry['+levelNum+'].color']);
	color2 = getSelectedValueFromSelectBox(form['entry['+levelNum+'].color2']);
	width = getValueFromTextField(form['entry['+levelNum+'].width']);
	
	return new Level(types, type, roots, root, colors, color, color2, width, levelNum);	
}

function getValueFromTextField(field){
	if (!field)
		return null;	
	return field.value;	
}

function getOptionsFromSelectBox(box){
	var array = new Array();
	if (box && box.options){
		for (var i = 0; i < box.options.length; i++){
			array.push(new SelectOption(box.options[i].text, box.options[i].value));	
		}
	}
	return array;
}

function getSelectedValueFromSelectBox(box){
	if (!box || !box.options)
		return null;
	return box.options[box.selectedIndex].value;	
}

function SelectOption(text, value){
	this.text = text;
	this.value = value;
	this.toString = function(){return "text: " + text + ", value: " + value};	
}

function arrayContains(array, value){
	if (!array)
		return false;
	for (var i = 0; i < array.length; i++){
		if (array[i] == value)
			return true;	
	}
	return false;	
}

function init(){
	preferenceBox = new PreferenceBox("tablePrefs", "TreemapPreferenceForm");
}

function hasColor2(levelNum){
	return (document.TreemapPreferenceForm['entry['+levelNum+'].color2'] && true); //this converts to a boolean	
}
function getRoot(levelNum){
	return document.TreemapPreferenceForm['entry['+levelNum+'].root'];	
}


function dumpFormContents(form){
	if (!form) return;
	
	var elems = form.elements;
	for (var i = 0; i < elems.length; i++){
		debug("Name: " + elems[i].name + ", type: " + elems[i].type);		
	}	
}