// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

// xdruntime.js

/////////////////////////////////////////////////////////////
///////////global variables//////////////////////////////////////
/////////////////////////////////////////////////////////////
var treeTop = null;
var provisioningPopup = null; //handle for the provisioningPopup (points to either a <div> or a <layer>
var buffer = "";
var intervalHandle = null;
var currentRootName=null;
var jasmsNode;
var nodesNode;
var currPurpose = DEFAULT_PURPOSE;
var currRootSelection = null;
var httpConnectors = new Object();

var REFRESH_DELAY = 60; //every 60 seconds
var OP_CODE_INIT = 0;
var OP_CODE_UPDATE = 1;

var connect_fail = 0;  //will get reset once reloaded

function createDataTree()
{
	treeTop = new Array();
}


function getItemById(id)
{
	var obj;
	if(document.getElementById)
	obj = document.getElementById(id);
	else if(document.all)
	obj = document.all[id];
	else if(document.layers)
	obj = document.layers[id];
	
	return obj;
}


///fetchers/////////////////////////////////////////////////////////////

function getNode(nodeGroupName, nodeName)
{
	var id = "NODE_" + nodeGroupName + "_" + nodeName;
	return nodeIndex[id];
}

/////////////////////////////////////////////////////////////////////////


//this function displays a popup screen at the current cursor location, containing
//a list of the currently provisioning jasm instances in the node represented by nodeId.
//Only those jasm instances with the state represented by the
//onMouseOver'd image (one is deprovisioning, one is provisioning) will be listed
//this function stores a handle in the global variable "provisionPopup" which can be used to
//remove the popup onMouseOut

var nodeWithCurrentPopup = null; //added this to fix case where a provisioning icon would disappear and leave the provisioning popup on the page
var currentProvPopupState = null;

function displayProvisioningPopup(nodeId, state, e)
{
	if(!e)
	e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	
	hideProvisioningPopup();
	
	var node = nodeIndex[nodeId];
	if(node == null)
	{
		return;
	}
	nodeWithCurrentPopup = node;
	currentProvPopupState = state;
	
	var jasmInstanceList = new Array();
	var heading;
	
	if(state == "starting") heading = STARTING + ":";
	else heading = STOPPING+":";
	
	jasmInstanceList.push(heading);
	//get a list of all jasm instances whose state match "state"
	for(var x = 0; x < node.children.length; x++)
	{
		if(node.children[x].state == state)
		jasmInstanceList.push(node.children[x].content);
	}
	
	if(jasmInstanceList.length == 1) return; //don't display if it's empty
	
	populateProvisioningPopup(jasmInstanceList);
	
	if(!placePopup(e))
	return; //don't know what coords to use...can't show it
	showProvisioningPopup();
	
}

//creates a pseudo-event object (just has clientX and clientY properties for usage in placePopup)
function displayPopupOnFocus(nodeId, targetObj, nodeType, purpose){
	//use top right corner of the box
	var x = targetObj.offsetLeft + targetObj.offsetWidth;
	var y = targetObj.offsetTop;
	var pseudoE = {clientX:x, clientY:y};
	displayPopup(nodeId, pseudoE, nodeType, purpose);
}

function displayPopup(nodeId, e, nodeType, purpose){
	if (!e)
		e = event;
	var popupFunction = popupFunctions[nodeType];
	if (popupFunction){
		var node = nodeIndex[nodeId];
		if (node){
			if(!provisioningPopup) return; //none exists...return before we get errors
			hidePopup();
			nodeWithCurrentPopup = node;
			currentProvPopupState = null;			
			if (popupFunction(node, e, purpose)){	
				if(!placePopup(e))
					return; //don't know what coords to use...can't show it
				showPopup();
			}
		}
	}
}

function hidePopup(){
	hideProvisioningPopup();
}

function showPopup(){
	showProvisioningPopup();	
}

function displayNumChildrenPopup(nodeId, e)
{
	if(!e)
	e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	
	hideProvisioningPopup();
	var node = nodeIndex[nodeId];
	
	populateProvisioningPopup([RUNNING_INSTANCES + ": " + node.childCount]);
	if(!placePopup(e))
	return;
	showProvisioningPopup();
}

function displayJASMWeightPopup(nodeId, e)
{
	if(!e)
	e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	
	hideProvisioningPopup();
	var node = nodeIndex[nodeId];
	
	if(!node.weight) return;
	
	var listToDisplay = [DWLM_WEIGHT + ": " + node.weight];
	if(node.pid)
	listToDisplay.push(PID + ": " + node.pid);
	
	populateProvisioningPopup(listToDisplay);
	if(!placePopup(e))
	return;
	showProvisioningPopup();
}

//creates a pseudo-event object (just has clientX and clientY properties for usage in placePopup)
function displaySingleStringPopupOnFocus(msg, targetObj){
	//use top right corner of the box
	var x = targetObj.offsetLeft + targetObj.offsetWidth;
	var y = targetObj.offsetTop;
	var pseudoE = {clientX:x, clientY:y};
	displaySingleStringPopup(pseudoE, msg);
}

function displaySingleStringPopup(e, msg)
{
	if(!e)
		e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	var listToDisplay = new Array();
	hideProvisioningPopup();
	listToDisplay.push(msg);	
	populateProvisioningPopup(listToDisplay);
	
	if(!placePopup(e))
	return;
	showProvisioningPopup();
}

function displayPopupFromListOnFocus(list, targetObj){
	//use top right corner of the box
	var x = targetObj.offsetLeft + targetObj.offsetWidth;
	var y = targetObj.offsetTop;
	var pseudoE = {clientX:x, clientY:y};
	displayPopupFromList(pseudoE, list);
}

function displayPopupFromList(e, list){
	if (!e)
		e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	hideProvisioningPopup();
	populateProvisioningPopup(list);
	
	if(!placePopup(e))
	return;
	showProvisioningPopup();
}

//returns true if the popup has been populated
function placePopup(e)
{
	if(e.pageX != undefined)
	placeProvPanel(e.pageX + 10, e.pageY);
	else if(e.clientX != undefined)
	placeProvPanel(e.clientX + 10, e.clientY);
	else return false;
	return true;
}

function placeProvPanel(x, y)
{
	if(provisioningPopup.style)
	{
		provisioningPopup.style.top = y;
		provisioningPopup.style.left = x;
	}
	else
	{
		provisioningPopup.top = y;
		provisioningPopup.left = x;
	}
}

//this function hides the provisioning popup, if it's currently displayed.
function hideProvisioningPopup()
{
	nodeWithCurrentPopup = null;
	currentProvPopupState = null;
	
	if(provisioningPopup == null) return;
	
	//handle it in a browser by browser fashion
	if(provisioningPopup.style)
	{
		provisioningPopup.style.visibility = "hidden";
	}
	else
	{
		provisioningPopup.visibility = "hide";
	}
}

//this function shows the provisioning popup, if it's not currently displayed.
function showProvisioningPopup()
{
	if(provisioningPopup == null) return;
	
	//handle it in a browser by browser fashion
	if(provisioningPopup.style)
	{
		provisioningPopup.style.visibility = "visible";
	}
	else
	{
		provisioningPopup.visibility = "show";
	}
}

function populatePopup(list){
	populateProvisioningPopup(list);
}

function populateProvisioningPopup(list)
{
	var text = "";
	var notFirst = false;
	for(var i = 0; i < list.length; i++)
	{
		if(notFirst) text += "<BR>";
		text += list[i];
		notFirst = true;
	}
	
	if(provisioningPopup.innerHTML != undefined)
		provisioningPopup.innerHTML = text;
	else if(provisioningPopup.layers)
	{
		var doc = provisioningPopup.layers["provPanel"].document;
		doc.open();
		doc.write(text);
	}
}

function createProvisioningPopup()
{
	
	document.writeln('<div id="provPanel" style="position:absolute; top:0; left:0; padding:5; background-color:white; border-color:black; border-style:solid; border-width:1;"><span class="provPanel" id="provPanelSpan"></span></div>');
	
	provisioningPopup = document.getElementById("provPanel");
	
	hideProvisioningPopup();
	return provisioningPopup;
}

var debugBox = null;
function debug(msg)
{
	return; //DISABLED RIGHT NOW
	if(debugBox == null)
	debugBox = document.getElementById("debug");
	if(debugBox == null)
	buffer += msg + "\n";
	else
	{
		debugBox.value += buffer + msg + "\n";
		buffer = "";
	}
}

//rootNames is an array of XML elements
function populateSelectBox(rootNames, firstRootName, iter)
{
	var selectBox = parent.topologyTop.document.getElementById("selectBox");
	var requestName = '<%=request.getParameter("name")%>';
	
	if(iter < 30)
	{
		if(!selectBox)
		setTimeOut("populateSelectBox('" + rootNames + "', '" + firstRootName + "', " + (iter+1) + ")");
	}
	
	selectBox.length = 0; //clear it	
	
	//add all nodegroups to the select box
	var defaultSelected = false;
	for(var i = 0; i < rootNames.length; i++)
	{
		var ngn = rootNames[i].getAttribute("name");
		if(ngn == firstNodeGroup)
			defaultSelected = true;
		selectBox.options[selectBox.options.length] = new Option(ngn, ngn, defaultSelected, defaultSelected);
		if ((requestName != null) && (requestName == ngn))
			selectBox.selectedIndex = i;
		defaultSelected = false;
	}
}

function getHTTPConnector(id, callback)
{
        if(window.ActiveXObject)
        {
                xmlhttp = new ActiveXObject('MSXML2.XMLHTTP');
        }
        else
        {
                xmlhttp = new XMLHttpRequest();
        }
        if (xmlhttp && callback){
                xmlhttp.onreadystatechange = callback;
                httpConnectors[id] = xmlhttp; //users might need to be able to look up their connector to query state of their conn
        }
        return xmlhttp;
}

var useCurrent = new Object();
useCurrent.toString = printCurrent;

function printCurrent()
{
	return "currentRootName";
}


var rootDiv;


function updateData(purpose, rootNameParam, op)
{
    if (connect_fail==0){
        var rootName;	

	//Now we get the rootName from the selectBox....if its the first time in....we get "All"
	rootName = getRootSelection();

  	if (currentRootName == null)
  		currentRootName = ALL_LABEL;

	
	if (!rootName || rootName != currentRootName){
		op = OP_CODE_INIT;
	}
	
	var xmlhttp = getHTTPConnector(processNewInfo);	
	var xmlDoc = null;
	var param = "?ts=" + Math.random();

	if (purpose != null)
		param += "&purpose=" + purpose;
		
	if(rootName != null)
	{
		currentRootName = rootName;
		param += "&root=" + rootName;
		if(op != undefined)
			param += "&op=" + op;
	}
	sUri = dataRequestUrl + param;
	//alert(sUri);
	if(xmlhttp)
	{
		try
		{
			xmlhttp.open('GET', sUri, false);
			xmlhttp.send(null);
			processNewInfo();
		}
		catch(e)
		{
            connect_fail = 1;
            //alert('Connection failure to Deployment Manager.  Will disable auto-refresh.  Please reload page to reactivate auto-refresh once connectivity issue has been resolved.');
			//alert('exception: ' + e.message);
			//something bad happened with the connection attempt, catch the exception
		}
	}
     }		
	//NESTED FUNCTION (could be used as asynch callback, just comment the processNewInfo() call right above this comment, and uncomment
	//the assignment of xmlhttp's onreadystatechange property)
	function processNewInfo()
	{
		var firstTime = false;
	
		if(xmlhttp && xmlhttp.readyState == 4)
		{
			//if we just finished receiving a response
      		xmlDoc = xmlhttp.responseXML;
            if (xmlDoc!=null)
            {
              	var opCode;
				var cell = xmlDoc.documentElement;	
				if (!cell)
					return;
		
				currPurpose = cell.getAttribute(ATTR_PURPOSE);
			  	if (currPurpose == PURPOSE_INIT || !currPurpose)
					currPurpose = DEFAULT_PURPOSE;
			  	setCentricityBox(currPurpose);

			  	if (op == OP_CODE_INIT)
			  	{
					currentRootName = init(cell, purpose);
					firstTime = true;
			  	}

			  	if (currentRootName)
			  	{
              		var rootNode = getRootNode(currPurpose, cell);
					// The returned rootNode is an array if it is not null.
					if (rootNode != null)
					{
						var nodeRootName = rootNode[0].getAttribute(ATTR_NAME);
						//if (nodeRootName && nodeRootName != currentRootName)
						//	currentRootName = nodeRootName;				
						// recursively display every child entry with details under cell.
						handleXMLElement(currPurpose, cell, null);
					}
			  	}
          	}
		}
				
		if (firstTime)
			recallPreviousState();
	
                //alert(op);		
	        if (currentRootName && op == OP_CODE_UPDATE)	
            		displayGraph(currentRootName,op);
	}

}

// This function returns the top matched node. If nothing is matched, it
// returns nullu
function init(cellElem, purpose)
{
	if (!cellElem){
		//alert("cellElem was null");
		return null;
	}
	
	emptyRootDiv();
	delete nodeIndex;
	delete tree_root;
	tree_root = null;
	treeDisplayed = false;
	isAll = false;
	
	nodeIndex = new Array();
	maxNodes = 0;
			
	if (purpose == PURPOSE_INIT)
		purpose = cellElem.getAttribute(ATTR_PURPOSE);
	if (!purpose)
		purpose = DEFAULT_PURPOSE;
	currPurpose = purpose;

	var initer = initFunctions[purpose];
	var rootElem = initer(cellElem);
	// The returned rootElem is an array if it is not null.
	if (!rootElem)
		return null;

	// There is at least one child.
	var type = rootElem[0].getAttribute(ATTR_TYPE);
	var id = rootElem[0].getAttribute(ATTR_ID);
	//var rootName = rootElem[0].getAttribute(ATTR_NAME);
	var rootName;
	
	if (currRootSelection) //if its been set on the selectBox use that value
		rootName = currRootSelection;
	else
		rootName = ALL_LABEL;
	//currentRootName = ALL_LABEL;

	//build the tree beginning at cell level
	var rootNode = addRoot("", cellElem, purpose);

	displayTree(purpose, rootDiv, rootNode, "", false, true, 1);
	treeDisplayed = true;
	
	firstTime = false; //setup for recall routine
	
    return rootName;
}


// This function returns null if nothing is matched; otherwise, it returns
// an array that contains matched child nodes.
function getRootNode(purpose, cell){
	if (purpose == PURPOSE_NODEGROUP_CENTRIC)
		typeWeAreLookingFor = ELEMENT_NODEGROUP;
	else if (purpose == PURPOSE_APPLICATION_CENTRIC)
		typeWeAreLookingFor = ELEMENT_APPLICATION;
	else if (purpose == PURPOSE_OPPOLICY_CENTRIC)
		typeWeAreLookingFor = ELEMENT_SERVICECLASS;
			
	var node = null;
	var nodeArray = new Array();
	var matchCount = 0;
	// put every child that has the type that we are looking for into
	// an array, except All. If there are more than one matches, then
	// set isAll to true.
        for (var i = 0; i < cell.childNodes.length; i++){
		node = cell.childNodes.item(i);
                if (node.getAttribute(ATTR_TYPE) == typeWeAreLookingFor) {
			matchCount++;
			if (matchCount > 1)
				isAll = true;
			if (node.getAttribute(ATTR_NAME) != "All")
				nodeArray.push(node);
		}
	}
	if (nodeArray.length > 0)
		return nodeArray;
	else
		return null;
}

//this is the entry point to this code.  It is called from the .jsp directly
//rootLevelName could be nodegroupname, application name, etc. - name of whatever node is the root
function getCellData(purpose, rootLevelName)
{
   var intervalBox;
   var refreshRate = REFRESH_DELAY;
    //alert("getCellData");
    if (rootLevelName)
		currentRootName = rootLevelName;
	
        updateData(purpose, rootLevelName, OP_CODE_INIT);	
	

	//refresh every REFRESH_DELAY milliseconds
	if(intervalHandle)
		window.clearInterval(intervalHandle);

	if (parent.topologyTop) {
		if (parent.topologyTop.document.getElementById('intervalBox')) {
			intervalBox = parent.topologyTop.document.getElementById('intervalBox');
			refreshRate = intervalBox.value;
		}
	}
	
	intervalHandle = window.setInterval("updateData('"+currPurpose+"', useCurrent, "+OP_CODE_UPDATE+");", refreshRate * 1000);
}


function delTreeNode(id)
{
//alert('deleting id: '  + id);
	var node = nodeIndex[id];
	if (!node){
	//	alert("node: " + id + " didn't exist");
		return;
	}

	if (node == nodeWithCurrentPopup)
		hideProvisioningPopup();
		
	if(node.childCount > 0)
	{
		for(var x = node.children.length - 1; x >= 0; x--)
		{
			delTreeNode(node.children[x].id);
		}
	}
	if (node.layer)
		rootDiv.removeChild(node.layer);
	removeFromParent(node);
	delete nodeIndex[id]; //remove this node from the nodeIndex
}


function removeFromParent(node)
{
	var childrenArray = node.parent.children;
	var i = 0;
	while(i < childrenArray.length)
	{
		if(childrenArray[i] == node)
		break;
		i++;
	}
	
	//move the rest of the children
	var lenMinusOne = childrenArray.length - 1;
	while(i < lenMinusOne)
	{
		childrenArray[i] = childrenArray[i+1];
		i++;
	}
	
	node.parent.children.length--;
	node.parent.childCount--;
}

function removeFromSelectBox(nodegroupname)
{
	var options = parent.topologyTop.selectBox.options;
	var index = indexInList(options, nodegroupname);
	if(index > -1)
	options[index] = null;
}

function clearSelectBox(){
	if (parent.topologyTop.selectBox && parent.topologyTop.selectBox.options && parent.topologyTop.selectBox.options.length > 0){
	var options = parent.topologyTop.selectBox.options;
	options.length = 0;	
	}
}

function indexInList(a, b)
{
	for(var i = 0; i < a.length; i++)
	{
		if(a[i].value == b)
		return i;
	}
	return -1;
}

function addToSelectBox(rootName)
{
	var displayName="";
	
	if (rootName == "All")
		displayName = ALL_LABEL;
	else
		displayName = rootName;	

	var options = parent.topologyTop.selectBox.options;
	if(indexInList(options, rootName) == -1)
		options[options.length] = new Option(displayName, rootName, false, false);
}


var graphInited = false;
var currGraphName;
var currGraphScope;
var cellWidth, totalWidth;
function displayGraph(tempName,opCode)
{
        //alert("displayGraph enter");
	var graphWindow = window.parent[graphFrameName];
	if(graphWindow)
	{
                //alert("DG 1");
		var newchart = false;
		var newScope='';	
		var newMetric = 'rt';	
		var newSet = 'dc';
                var newDatSets='';
			
		var selectBox = parent.topologyTop.document.getElementById('selectBox');
		var selectCentricity = parent.topologyTop.document.getElementById('selectCentricity');
		var newName = selectBox.options[selectBox.selectedIndex].value;	
                //alert(newName);
		// Use the fist entry to display in the data name of the chart
		// perferences if All is selected.
		if (newName == ALL_LABEL)
			newName = selectBox.options[0].value;	
		var purpose = selectCentricity.options[selectCentricity.selectedIndex].value;
   		
		if (purpose == PURPOSE_NODEGROUP_CENTRIC)
                        newScope = 'ng';
                else if (purpose == PURPOSE_APPLICATION_CENTRIC)
                        newScope = 'app';
                else if (purpose == PURPOSE_OPPOLICY_CENTRIC)
                        newScope = 'sc';		
	

		//alert('reqScope=' + requestScope + ' reqName=' + requestName + ' reqMetric=' + requestMetric);	
		if (requestScope != 'null')
			newScope = requestScope;
			
		if (requestName != 'null')
			newName = requestName;

                newDataSets = newName;

	        //alert("DG 2");		
		if (requestMetric != 'null')
			newMetric = requestMetric;
		
		if (requestSet != 'null')
			newSet = requestSet
	        //alert("DG 3");	
		if (newScope != currGraphScope || newName != currGraphName) {
			newchart = true;
		}
		
		if (requestDataSets != 'null')
			newDataSets = requestDataSets;	
	        //alert("DG 4");	
			
                //alert("DG 5");		
		//alert('newScope=' + newScope + ' newName=' + newName + ' newMetric=' + newMetric + 'newDataSets=' + newDataSets);
                //alert(opCode);
                if(!opCode || opCode == OP_CODE_INIT){
		if(!graphInited)
		{
                        //alert("DG 6");

			var loc = graphJSP + "?initial=true&scope=" + newScope + "&name=" + newName + "&subdomain=" + newSet + "&datasets=" + newDataSets + "&metric=" + newMetric + "&type=line&yaxis2=none&filter=none&currWindow=" + graphWindow.name;
                        //alert(loc);
                        graphWindow.location = loc;
                        //alert("DG 6.a");
			graphInited = true;
			currGraphName = newName;
			currGraphScope = newScope;
                        //alert("DG 7");
		}
		else if (newchart) {
                        //alert("DG 8");
			currGraphName = newName;
			currGraphScope = newScope;
			var xmlhttp;
			if(window.ActiveXObject) {
				xmlhttp = new ActiveXObject('MSXML2.XMLHTTP');
			} else  {
				xmlhttp = new XMLHttpRequest();
			}
			var table = graphWindow.document.getElementById("collectionTable");
			var chartTable = graphWindow.document.getElementById("chartTable");

			if (table) {	
				var firstCell = table.rows[0].cells[0];
				cellWidth = firstCell.offsetWidth;
				//alert('cellWidth=' + cellWidth);
				if (chartTable) {
					totalWidth = chartTable.offsetWidth;
					//alert('totalWidth=' + totalWidth);
				}
			}
			
			sUri1 = chartCollectionUrl + "?new=true&scope=" + newScope + "&name=" + newName + "&subdomain=" + newSet + "&datasets=" + newDataSets + "&metric=" + newMetric + "&type=line&yaxis2=none&filter=none&cellWidth=" + cellWidth + "&totalWidth=" + totalWidth + "&currWindow=graphFrame";
			
			var random = "&random=" + Math.random();
			sUri1 = sUri1 + random;			
			if(xmlhttp) {
				try {
					xmlhttp.open('GET', sUri1, false);
					xmlhttp.send(null);
					
				} catch(ex) {
					//something bad happened with the connection attempt, catch the exception
				}
				graphWindow.location = graphJSP + "?initial=true&scope=" + newScope + "&name=" + newName + "&subdomain=" + newSet + "&datasets=" + newDataSets + "&metric=" + newMetric + "&type=line&yaxis2=none&currWindow=graphFrame";
			}
                        //alert("DG 9");
		}			
		else
		{
                        //alert("DG 10");
			if (graphWindow.reload){
                                //alert("reloading");
				graphWindow.reload();
                         }
		}
                }
                else if (opCode && opCode == OP_CODE_UPDATE)
                {
                        //alert("DG 11");
                        if (graphWindow.reload){
                                //alert("reloading");
                                graphWindow.reload();
                         }
                }
                else
                {
                       alert("should never reach this point");
                }
	}
        //alert("displayGraph exit");
	
}

function emptyRootDiv()
{
	if (!rootDiv)
		return;
		
	var children = rootDiv.childNodes;
	var childrenLen = children.length;
	
	for(var x = 0; x < childrenLen; x++)
	{
		rootDiv.removeChild(children[children.length-1]); //always remove the last one
	}
}

//sets the selected value of the select box to the input parameter, if an option by that name exists in the select box
function setSelectBox(rootname)
{
	if (currRootSelection == null)
		currRootSelection = ALL_LABEL;
		
	rootname = currRootSelection; //use the value set from the jsp or "All" if first time
	
	var selectBox = parent.topologyTop.document.getElementById("selectBox");
	var options = selectBox.options;
	for(var i = 0; i < options.length; i++)
	{
		if(options[i].value == rootname && selectBox.selectedIndex != i)
		selectBox.selectedIndex = i;
	}
}

//sets the selected value of the select box to the input parameter, if an option by that name exists in the select box
function setCentricityBox(purpose)
{
	//this changes the "select a XXXXXX" text
	if (parent.topologyTop && parent.topologyTop.setPurpose)
		parent.topologyTop.setPurpose(purpose);
	
	var selectBox = parent.topologyTop.document.getElementById("selectCentricity");
	if (selectBox){
		var options = selectBox.options;
		for(var i = 0; i < options.length; i++)
		{
			if(options[i].value == purpose && selectBox.selectedIndex != i){
				selectBox.selectedIndex = i;
				currPurpose = purpose;
				return;
			}
		}
	}
}

function setPurposeInTopology(purpose){
	currPurpose = purpose;
	getCellData(purpose, null);
}

function setRootSelectionInTopology(rootSelection)
{
	currRootSelection = rootSelection;
	getCellData(currPurpose, rootSelection);
}

function getRootSelection()
{
	if (currRootSelection == null)
		currRootSelection = ALL_LABEL;

	return currRootSelection;
}
