#!/bin/sh

# THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
# 5724-J34, 5655-P28  (C) COPYRIGHT International Business Machines Corp., 2005,2006
# All Rights Reserved * Licensed Materials - Property of IBM
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

      
binDir=`dirname $0`
. $binDir/setupCmdLine.sh

if [ -f ${JAVA_HOME}/bin/java ]; then
    JAVA_EXE="${JAVA_HOME}/bin/java"
else
    JAVA_EXE="${JAVA_HOME}/jre/bin/java"
fi

if [ ! -f ${JAVA_HOME}/lib/tools.jar ]; then
    JAVA_HOME="${JAVA_HOME}/.."
fi

# ensure user is calling wpfStubUtil properly in the following manner:
# wpfStubUtil.cmd -ear D_WPFKeyBasedPartitionSample.ear -jar WPFKeyBasedPartitionEJB.jar
# -class com/ibm/websphere/wpf/ejb/WPFKeyBasedPartition.class -temp \temp [optional flags and classpaths]
if [ "$1" != "-ear" ] ; then
  echo You must call wpfStubUtil with the following options in the correct order:
  echo "wpfStubUtil -ear <earname> -jar <jarname> -class <classname> -temp <temp working directory> [optional flags: -stubUpdateClasspath <classpath> -verbose -stubDebug -keep -rmicextclasspath <classpath> -extdirs <javac extdirs>]"
  echo "NOTE: The -stubUpdateClasspath command is optional, but if it is used it must be the first argument after the temp working directory"
elif [ "$3" != "-jar" ] ; then
  echo You must call wpfStubUtil with the following options in the correct order:
  echo "wpfStubUtil -ear <earname> -jar <jarname> -class <classname> -temp <temp working directory> [optional flags: -stubUpdateClasspath <classpath> -verbose -stubDebug -keep -rmicextclasspath <classpath> -extdirs <javac extdirs>]"
  echo "NOTE: The -stubUpdateClasspath command is optional, but if it is used it must be the first argument after the temp working directory"
elif [ "$5" != "-class" ] ; then
  echo You must call wpfStubUtil with the following options in the correct order:
  echo "wpfStubUtil -ear <earname> -jar <jarname> -class <classname> -temp <temp working directory> [optional flags: -stubUpdateClasspath <classpath> -verbose -stubDebug -keep -rmicextclasspath <classpath> -extdirs <javac extdirs>]"
  echo "NOTE: The -stubUpdateClasspath command is optional, but if it is used it must be the first argument after the temp working directory"
elif [ "$7" != "-temp" ] ; then
  echo You must call wpfStubUtil with the following options in the correct order:
  echo "wpfStubUtil -ear <earname> -jar <jarname> -class <classname> -temp <temp working directory> [optional flags: -stubUpdateClasspath <classpath> -verbose -stubDebug -keep -rmicextclasspath <classpath> -extdirs <javac extdirs>]"
  echo "NOTE: The -stubUpdateClasspath command is optional, but if it is used it must be the first argument after the temp working directory"
else
  # $8/$4 for rmic, executes in local directory of program, vs. tempdir
  # $4 for javac so has reference to the partition key class
  mkdir -p $8

  if [ "$9" != "-stubUpdateClasspath" ] ; then
    export PATH=$WAS_PATH
    export CLASSPATH=$JAVA_HOME/lib/tools.jar:$WAS_CLASSPATH:.:$8:$8/$4:$CLASSPATH

    $JAVA_EXE -Dwas.install.root="$WAS_HOME" -Duser.install.root="$USER_INSTAL_ROOT" -Dws.ext.dirs="$WAS_EXT_DIRS" com.ibm.ws.bootstrap.WSLauncher com.ibm.ws.wpf.WPFStubUtil $@
  else
    shift
    export PATH=$WAS_PATH
    export CLASSPATH=$JAVA_HOME/lib/tools.jar:$WAS_CLASSPATH:.:$7:$7/$3:$9:$CLASSPATH
    $JAVA_EXE -Dwas.install.root="$WAS_HOME" -Duser.install.root="$USER_INSTAL_ROOT" -Dws.ext.dirs="$WAS_EXT_DIRS" com.ibm.ws.bootstrap.WSLauncher com.ibm.ws.wpf.WPFStubUtil $@
  fi
fi    
