#!/bin/sh

# All Rights Reserved * Licensed Materials - Property of IBM
# 5724-J34 (C) COPYRIGHT International Business Machines Corp., 2005
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

# Highly Available Deployment Manager Removal Utility

SHELL=com.ibm.ws.xd.admin.hadmgr.config.HadmgrRemoveUtility

binDir=`dirname $0`
. $binDir/setupCmdLine.sh

#Platform specific args...
PLATFORM=`/bin/uname`
case $PLATFORM in
  AIX)
    CONSOLE_ENCODING=-Dws.output.encoding=console
    LIBPATH="$WAS_LIBPATH":$LIBPATH
    export LIBPATH ;;
  Linux)
    CONSOLE_ENCODING=-Dws.output.encoding=console
    LD_LIBRARY_PATH="$WAS_LIBPATH":$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH ;;
  SunOS)
    CONSOLE_ENCODING=-Dws.output.encoding=console
    LD_LIBRARY_PATH="$WAS_LIBPATH":$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH ;;
  HP-UX)
    CONSOLE_ENCODING=-Dws.output.encoding=console
    SHLIB_PATH="$WAS_LIBPATH":$SHLIB_PATH
    export SHLIB_PATH ;;
  OS/390)
    PATH=$binDir:$PATH
    export PATH
    EXTRA_D_ARG1=-Dfile.encoding=ISO8859-1
    EXTRA_D_ARG2=-Djava.ext.dirs="$JAVA_EXT_DIRS"
    EXTRA_X_ARGS=-Xnoargsconversion ;;
esac


# For debugging the utility itself
# WAS_DEBUG="-Djava.compiler=NONE -Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=7777"

"$JAVA_HOME"/bin/java \
  -Xbootclasspath/p:"$WAS_BOOTCLASSPATH" \
  $EXTRA_X_ARGS \
  $WAS_DEBUG \
  $CONSOLE_ENCODING \
  "$CLIENTSAS" \
  "$CLIENTSSL" \
  "$CLIENTSOAP" \
  ${JAASSOAP:+"$JAASSOAP"} \
  -Dws.ext.dirs="$WAS_EXT_DIRS" \
  -Dwas.install.root="$WAS_HOME" \
  -DWAS_HOME="$WAS_HOME" \
  -Djava.util.logging.manager=com.ibm.ws.bootstrap.WsLogManager \
  -Djava.util.logging.configureByServer=true \
  $EXTRA_D_ARG1 \
  $EXTRA_D_ARG2 \
  $USER_INSTALL_PROP \
  $PROCNAMES \
  $JVM_EXTRA_CMD_ARGS \
  -classpath "$WAS_CLASSPATH" \
  com.ibm.ws.bootstrap.WSLauncher \
  $SHELL "$CONFIG_ROOT" "$WAS_CELL" "$WAS_NODE" "$@"

exit $?
