# (C) Copyright IBM Corp. 2004,2005 - All Rights Reserved.
# DISCLAIMER:
# The following source code is sample code created by IBM Corporation.
# This sample code is provided to you solely for the purpose of assisting you
# in the  use of  the product. The code is provided 'AS IS', without warranty or
# condition of any kind. IBM shall not be liable for any damages arising out of your
# use of the sample code, even if IBM has been advised of the possibility of
# such damages.


# workclassoperations.py - creates, updates work classess for enterprise
# applications and generic server clusters. It can also, list rules in a 
# work class, list URIs in a work class, fetch default action, set default 
# action, add rule, delete rule, delete URIs, and delete work  classes for 
# the various policies and communication protocols. 
#
# Date Created: 04/28/2005
#

#
# 
import jarray
from java.lang import System
from com.ibm.ws.grid import AppTypeDeploymentTask
from com.ibm.ws.classify import Expression
from com.ibm.ws.xd.config.workclass.util import ApplicationUtil
from com.ibm.wsspi.classify import RuleParserException 

def getProtocolFromWorkClassType(aProtocol):
    if (aProtocol == "SOAPWORKCLASS"):
        return "SOAP"
    elif (aProtocol == "IIOPWORKCLASS"):
        return "IIOP"
    elif (aProtocol == "JMSWORKCLASS"):
        return "JMS"
    else:
        return "HTTP"

def setProtocolForWorkClass():
   if (myProtocolType == "SOAP"):
      protocolType = "SOAPWORKCLASS"
   elif (myProtocolType == "IIOP"):
      protocolType = "IIOPWORKCLASS"
   elif (myProtocolType == "JMS"):
      protocolType = "JMSWORKCLASS"
   else:
      protocolType = "HTTPWORKCLASS"
   return protocolType 

def displayRules(wcId):
     mAction=""
     mExpr=""
     rList = AdminConfig.showAttribute(wcId,"matchRules").replace("[","").replace("]","").split(" ")
     dAction = AdminConfig.showAttribute(wcId,"matchAction")
     #print "Len of rList is %i" %(len(rList))
     if (isGetDefaultAction == 1):
         print "Default Action: "+dAction
     else:
       for aRule in rList:
         try:
           mPriority=AdminConfig.showAttribute(aRule,"priority")
           mAction=AdminConfig.showAttribute(aRule,"matchAction")
           mExpr=AdminConfig.showAttribute(aRule,"matchExpression")
         except:
             print ""
         if (isListRule == 1):
             if (mExpr != "" and mAction != ""):
                print "Priority: "+mPriority+"; Expression: "+mExpr + "; Action: "+mAction
     
def isMatchOverlapping(aMatch):
    #if (patternOverlaps == ""):
    patternOverlaps = ""
    
    if (myWorkClassType == "ARP" or myWorkClassType == "ASP"):    
        if (myWorkClassType == "ARP"):
            patternOverlaps = getAppRoutingWorkClassesURIs()
        elif (myWorkClassType == "ASP"):
            patternOverlaps = getAppSLAWorkClassesURIs()

        patternOverlaps = patternOverlaps.split(",")
        
        for pattern in patternOverlaps:
            if (pattern == aMatch+" ("+myWebModule+")"):
                return "true"
            
    if (myWorkClassType == "GRP" or myWorkClassType == "GSP"):
        if (myWorkClassType == "GRP"):
            patternOverlaps = getGSCWorkClassesURIs("routing")
        elif (myWorkClassType == "GSP"):
            patternOverlaps = getGSCWorkClassesURIs("sla")
        
        patternOverlaps = patternOverlaps.split(",")
        
        for pattern in patternOverlaps:
            if (pattern == "*" and "/"+pattern == aMatch):
                return "true"
            if (pattern == aMatch):
                return "true"
    
    return "false"
 
      
def getAppRoutingWorkClassesURIs():
   wcNames=AdminConfig.list("WorkClass").split("\n")
   wcURIs = ""
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 ):
          if (checkForReservedWCID(wcName) == 0):
              appName = myAppName.split("-edition")[0]
              if (myProtocolType == getProtocolFromWorkClassType(AdminConfig.showAttribute(wcName, "type"))):
                  if (wcName.find(appName+".ear") > 0 and wcName.find("odr") == -1 and wcName.find("deployments") == -1):
                     wcmList = AdminConfig.showAttribute(wcName, "workClassModules").replace("[","").replace("]","").split(" ")
        
                     for wcm in wcmList: 
                        if (wcm == ""):
                           break                   
                        wcmId = wcm
                        wcmName = AdminConfig.showAttribute(wcmId, "moduleName")
                        uris = AdminConfig.showAttribute(wcmId, "matchExpression")
                        uris = uris.split(",")
                        wcmName = wcmName.split(".")[0]                
                        
                        for uri in uris:
                           if (wcURIs == ""):
                               wcURIs = uri+" ("+wcmName+")"
                           else:
                               wcURIs = wcURIs+","+uri+" ("+wcmName+")" 
   return wcURIs 

def getAppSLAWorkClassesURIs():
   wcNames=AdminConfig.list("WorkClass").split("\n")
   wcURIs = ""
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 ):
          if (checkForReservedWCID(wcName) == 0):
              if (myProtocolType == getProtocolFromWorkClassType(AdminConfig.showAttribute(wcName, "type"))):
                  if (wcName.find("/"+myAppName+"/") > 0 and wcName.find("deployments") > 0):              
                     wcmList = AdminConfig.showAttribute(wcName, "workClassModules").replace("[","").replace("]","").split(" ")
                     for wcm in wcmList: 
                        if (wcm == ""):
                           break                   
                        wcmId = wcm
                        wcmName = AdminConfig.showAttribute(wcmId, "moduleName")
                        uris = AdminConfig.showAttribute(wcmId, "matchExpression")
                        uris = uris.split(",")
                        wcmName = wcmName.split(".")[0]
                        
                        for uri in uris:
                           if (wcURIs == ""):
                               wcURIs = uri+" ("+wcmName+")"
                           else:
                               wcURIs = wcURIs+","+uri+" ("+wcmName+")" 
   return wcURIs  
 
def getGSCWorkClassesURIs(aPolicyType):
   wcNames=AdminConfig.list("WorkClass").split("\n")
   wcURIs = ""

   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 and wcName.find(aPolicyType) > -1 and wcName.find(myOdrName) > 0):
             wcmList = AdminConfig.showAttribute(wcName, "workClassModules").replace("[","").replace("]","").split(" ")
             for wcm in wcmList: 
                if (wcm == ""):
                   break              
                wcmId = wcm
                wcmName = AdminConfig.showAttribute(wcmId, "moduleName")
                uris = AdminConfig.showAttribute(wcmId, "matchExpression")
                uris = uris.split(",")
                wcmName = wcmName.split(".")[0]
                
                for uri in uris:
                   if (wcURIs == ""):
                       wcURIs = uri
                   else:
                       wcURIs = wcURIs+","+uri
   return wcURIs 

def checkForReservedWC():
    if (myWorkClassName.startswith("Default_") and myWorkClassName.endswith("_WC")):
        print ""
        print "You are not allowed to delete a default work class, goodbye."
        errorExit()

def checkForRequiredOptions():
  if (myWorkClassName == ""):
        print ""
        print "You must specify the work class name using the -wcname option."
  if (isAppWorkClasses == 1):
        if (myAppName == ""):
            print ""
            print "You have asked to process rules without specifying the enterprise application name."
            print "You must specify an enterprise application name using the -appname option."
        elif (isSystemApp == 1):
            anApp = findSystemApplication(myAppName)
        else:
            anApp=findDeployment(myAppName)
        if (anApp == None):
            print "The application " + myAppName + " specified cannot be found in this WAS deployment"
            errorExit()      
  else:
        if (myOdrNode == "" or myOdrName == ""):
            print ""
            print "The rule operations for generic server cluster require the ODR node and name."
            print "You must use both -odrname and -odrnode to specify the ODR and ODR node respectively."
        anOdrNode=findNode(myOdrNode)
        if (anOdrNode != None):
            anOdr=findProxyServer(myOdrName)
            if (anOdr == None):
                print ""
                print "The ODR name " +myOdrName + " does not exist on this server."
        else:
            print ""
            print "The ODR node " +myOdrNode + " does not exist on this server."
            
def processRulesForWorkClass():
    checkForRequiredOptions()
    if (isAppWorkClasses == 1):
        if (myWorkClassType == "ARP" or myWorkClassType == "APP"):
           wcid =findAppRoutingWorkClass(myWorkClassName, myAppName)
           if (wcid != None):
              if (isListRule == 1):
                 print ""
                 print "Printing routing rules for work class: " +myWorkClassName
              elif (isGetDefaultAction == 1):
                 print ""
                 print "Printing routing default action for work class: " +myWorkClassName
              displayRules(wcid)
        if (isPerformBoth == 1 or myWorkClassType == "ASP"):
            wcid = findAppSLAWorkClass(myWorkClassName, myAppName)
            if (wcid != None):
                print ""
                if (isListRule == 1):
                    print "Printing SLA rules for work class: " +myWorkClassName
                elif (isGetDefaultAction == 1):
                    print "Printing SLA default action for work class: " +myWorkClassName
                displayRules(wcid)
    else:
        if (myWorkClassType == "GRP"):
            wcid = findWorkClass(myWorkClassName,"routing")
            if (wcid != None):
               print ""
               if (isListRule == 1):
                     print "Printing routing rules for work class: " +myWorkClassName
               elif (isGetDefaultAction == 1):
                     print "Printing routing default action for work class: " +myWorkClassName
               displayRules(wcid)
        if (isPerformBoth == 1 or myWorkClassType == "GSP"):
            wcid = findWorkClass(myWorkClassName,"sla")
            if (wcid != None):
               print ""
               if (isListRule == 1):
                    print "Printing SLA rules for work class: " +myWorkClassName
               elif (isGetDefaultAction == 1):
                    print "Printing SLA default action for work class: " +myWorkClassName
               displayRules(wcid)

def removeRuleFromWorkClass(anId):
     rulePriority=-1
     ruleList = AdminConfig.showAttribute(anId,"matchRules").replace("[","").replace("]","").split(" ")
     if (isAppWorkClasses == 1):
         wctype = "enterprise application"
     else:
         wctype = "generic server cluster"
     if (len(ruleList)> 0):
         #print "The number of rules in this work class is %d"  %(len(ruleList))
         for ar in ruleList:
             if (len(ar) > 0):
                rulePriority = AdminConfig.showAttribute(ar,"priority")
                if (rulePriority == myDeleteRulePriority):
                   AdminConfig.remove(ar)   
                   print "Rule with priority " + myDeleteRulePriority + " has been deleted from "+wctype+" work class " +myWorkClassName    
                   break 
                                    
def deleteWorkClassRule(): 
  checkForRequiredOptions() 
  if (isAppWorkClasses == 1):
        wcid =findAppRoutingWorkClass(myWorkClassName, myAppName)
        if (wcid != None):
              removeRuleFromWorkClass(wcid)
        if (isPerformBoth == 1):
            wcid = findAppSLAWorkClass(myWorkClassName, myAppName)
            if (wcid != None):
                removeRuleFromWorkClass(wcid) 
  else:
      wcid = findWorkClass(myWorkClassName,"routing")
      if (wcid != None):
           removeRuleFromWorkClass(wcid)
      if (isPerformBoth == 1):
           wcid = findWorkClass(myWorkClassName,"sla")
           if (wcid != None):
               removeRuleFromWorkClass(wcid)
  AdminConfig.save()

##
# Displays URI for an HTTP WorkClass
#
def listHTTPWorkClassURI():
  checkForRequiredOptions()
  wc=findAppRoutingWorkClass(myWorkClassName, myAppName)
  if (wc != None):
    wcmList = AdminConfig.showAttribute(wc, "workClassModules").replace("[","").replace("]","").split(" ")
    for wcm in wcmList:
      if (wcm == ""):
         break
      wcmId = AdminConfig.showAttribute(wcm,"id")
      wcmNames = wcmId.split(":!:")
      if (wcmNames[1]==myAppName and wcmNames[2].startswith(myWebModule)):
           wcmURIS = AdminConfig.showAttribute(wcm,"matchExpression").split(",")
           print "URIs for routing policy work class."
           for wcmURI in wcmURIS:
              if (not wcmURI[0] == '/'):
                  separator = "/"
              else:
                  separator = ""
              print "/" +myAppName +separator+wcmURI
  # now look for service policy under the same workclass name
  #
  wc=findAppSLAWorkClass(myWorkClassName, myAppName)
  if (wc != None):
    wcmList = AdminConfig.showAttribute(wc,"workClassModules").replace("[","").replace("]","").split(" ")
    for wcm in wcmList:
      if (wcm == ""):
         break
      wcmId = AdminConfig.showAttribute(wcm,"id")
      wcmNames = wcmId.split(":!:")
      if (wcmNames[1]==myAppName and wcmNames[2].startswith(myWebModule)):
           wcmURIS = AdminConfig.showAttribute(wcm,"matchExpression").split(",")
           print "URIs for service policy work class."
           for wcmURI in wcmURIS:
              if (not wcmURI[0] == '/'):
                  separator = "/"
              else:
                  separator = ""
              print "/" +myAppName +separator +wcmURI
#
# A function for unmapping URI associated with a web module under a given enterprise
# application
#
def removeWorkClassURI():
    checkForRequiredOptions()
    # make sure URI input is well-formed
    uriList = myDeleteURIS.split("?")
    for uri in uriList:
        if (not uri[0] == '/'):
            uri = "/"+uri
    if (myWorkClassType == "" or myWorkClassType == "ARP"):
       wc=findAppRoutingWorkClass(myWorkClassName, myAppName)
    else:
       wc=findAppSLAWorkClass(myWorkClassName, myAppName) 
    if (wc != None):
       newURIs=""
       wcmList = AdminConfig.showAttribute(wc, "workClassModules").replace("[","").replace("]","").split(" ")
       for wcm in wcmList:
           if (wcm == ""):
               break
           wcmId = AdminConfig.showAttribute(wcm,"id")
           wcmNames = wcmId.split(":!:")
           if (wcmNames[1]==myAppName and wcmNames[2].startswith(myWebModule)):
               wcmURIS = AdminConfig.showAttribute(wcm,"matchExpression").split(",")
               for wcmURI in wcmURIS: 
                   for inURI in uriList:
                      if (wcmURI != inURI):
                         if (newURIs == ""):
                            newURIs = wcmURI
                         else:
                            newURIs = newURIs + "," + wcmURI 
               print "The new web module expression is: " + newURIs
               AdminConfig.modify(wcm,[["matchExpression", newURIs]])
    else:
        print ""
        print "The work class, '" + myWorkClassName + "', specified was not found."
        errorExit()  

def createSystemAppRoutingWorkClass():
   routingWorkClass=""
   actionValue=""
   oldURI=""
   appShortName=myAppName 
   print "the short appname = " + appShortName
   if (appShortName!=""):
       if (myDefaultAction != ""):
           dParts = myDefaultAction.split("?")
           actionType = dParts[0]
           actionValue = ""
           try:
              actionValue = dParts[1]
           except IndexError:
               if (actionValue == "" and actionType.startswith("permit")):
                   actionValue = appShortName
               else:
                   errorExit() 
           taskCmdArgs =  "[-appname "+ appShortName+" -wcname "+myWorkClassName+" -type "+myProtocolType+" -actiontype "+actionType+" -action "+actionValue+"]"                
           if (isModifyDefaultAction == 1):
                 routingWorkClass = findSystemAppRoutingWorkClass(myWorkClassName)
                 if (routingWorkClass != None):
                     AdminConfig.modify(routingWorkClass,[["matchAction", actionType+":"+actionValue]])
           else:
                 routingWorkClass = AdminTask.createSystemRoutingPolicyWorkClass(taskCmdArgs)          
       
       else:
          print "The workclass '"+myWorkClassName +"' specified does not exist or could not be created in this WAS deployment."
   else:
      errorExit()     
          
def createSystemAppSLAWorkClass():
   slaWorkClass=""
   appShortName=myAppName
   protocolType = setProtocolForWorkClass()
   if (appShortName!=""):
       if (myDefaultAction != ""):
           dParts = myDefaultAction.split("?")
           txclsName = dParts[0]
           tcName=findTransactionClass(txclsName)
           print "Tx Class = " + tcName
           if (tcName != None):   
                 wclassAttributes = [["matchAction",tcName],
                                     ["name",myWorkClassName],
                                     ["type",protocolType],
                                     ["description","This is a custom workclass."]]  
                 taskCmdArgs =  "[-appname "+ appShortName+" -wcname "+myWorkClassName+" -type "+myProtocolType+ " -tcname "+tcName +" -appEditionName  "+appShortName+"]"
                 if (isModifyDefaultAction == 1):
                        slaWorkClass = findSystemAppSLAWorkClass(myWorkClassName)
                        if (slaWorkClass != None):
                            AdminConfig.modify(slaWorkClass,[["matchAction", tcName]])
                 else:
                       slaWorkClass=AdminTask.createSystemServicePolicyWorkClass(taskCmdArgs)    
       else:
          print "The workclass '"+myWorkClassName +"' specified does not exist or could not be created in this WAS deployment."
   else:
      errorExit()       

def processAppWorkClassRequest():
    checkForRequiredOptions()
    # if workclass exists, then webmodule, uris, can be absent
    if (myRule[0] == None):
        print "Creating work class with only default rule and match expression or modifying existing work class."
    if (myRule[0] != None and (myRule[0].find("permit") > -1 or myRule[0].find("redirect") > -1 or myRule[0].find("permitsticky") > -1 or myRule[0].find("reject") > -1)):
        createAppRoutingWorkClass(myAppName, myWebModule, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Work Class for routing created or updated."
    elif (myDefaultAction != "" and (myDefaultAction.find("permit") > -1 or myDefaultAction.find("redirect") > -1 or myDefaultAction.find("permitsticky")> -1 or myDefaultAction.find("reject") > -1)):
        createAppRoutingWorkClass(myAppName, myWebModule, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Set Default Action for routing policy."
    elif (myURIS != "" and myWorkClassType == "ARP"):
        print "Updating Routing WorkClass URIs."
        createAppRoutingWorkClass(myAppName, myWebModule, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
    else:
        createAppSLAWorkClass(myAppName, myWebModule, myEJBName, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Work Class for service policy created or updated."
    print "*****************************************************************************************"        
    
    
def processGSCWorkClassRequest():
    checkForRequiredOptions()
    if (myRule[0] == None):
        print "Creating work class for generic server cluster with only default rule and action or modifying existing work class."
    if (myRule[0] != None and (myRule[0].find("permit") > -1 or myRule[0].find("redirect") > -1 or myRule[0].find("permitsticky") > -1 or myRule[0].find("reject") > -1)):
        createGSCRoutingWorkClass(myVirtualHost, myOdrNode, myOdrName, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Work Class for routing created or updated."
    elif (myDefaultAction != "" and (myDefaultAction.find("permit") > -1 or myDefaultAction.find("redirect") > -1 or myDefaultAction.find("permitsticky")> -1 or myDefaultAction.find("reject") > -1)):
        createGSCRoutingWorkClass(myVirtualHost, myOdrNode, myOdrName, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Work Class for GSC routing created with default action and expression."
    else:
        createGSCSLAWorkClass(myVirtualHost, myOdrNode, myOdrName, myDefaultAction, myWorkClassName, myProtocolType, myRule, myURIS)
        print "*****************************************************************************************"
        print ""
        print "Work Class for SLA created or updated." 
    print "*****************************************************************************************" 

def processSystemAppRequest():
    checkForRequiredOptions()
    # if workclass exists, then webmodule, uris, can be absent
    if (myDefaultAction != "" and (myDefaultAction.find("permit") > -1 or myDefaultAction.find("redirect") > -1 or myDefaultAction.find("permitsticky")> -1 or myDefaultAction.find("reject") > -1)):
        createSystemAppRoutingWorkClass()
        print "*****************************************************************************************"
        print ""
        print "Set Default Action for routing policy."  
    else:
        createSystemAppSLAWorkClass()
        print "*****************************************************************************************"
        print ""
        print "Work Class for service policy created or updated for system application."
    print "*****************************************************************************************"        


def validateExpression(anExpr):
    try:
        Expression(anExpr)
    except RuleParserException, msg:
        print "ERROR: The rule expression is invalid: ", msg
        errorExit()

def showRemoveWCHelp():
    print """
        DESCRIPTION
        This command option is used to remove an existing application work class. 
        
        Usage: wsadmin 
                      [-lang jython]
                      [-f workclassoperations.py]
                      [-wctype ARP|ASP|GRP|GSP]
                      [-odrname odrName] 
                      [-wcname workClassName]
                      [-appname applName]
                      [-deletewc]
                      [-systemapp]
                      
        COMMAND LINE OPTIONS
          -appname appName is used to specify the name of the enterprise application without the .ear extension. This option is required if deleting enterprise application work class.
          -deletewc is the operation to be performed, deletes the specified work class.
          -odrname odrName is used to specify the name of your On Demand Router (ODR) proxy server. This option is required if deleting generic server cluster work class. 
          -systemapp is used to indicate whether the application specified is a system application.
          -wcname workClassName is used to specify the name of the workclass, no spaces are allowed in the work class name. This option is required.
          -wctype takes a constant value of either ARP for enterprise application routing policy work class, ASP for enterprise application service policy work class, GRP for generic server cluster routing policy work class, or GSP for generic server cluster service policy work class. There is no default, so a value must be specified.
        
        EXAMPLES
        Example 1, wsadmin -lang jython -f workclassoperations.py -deletewc -wctype GSP -odrname ODR -wcname CustomWorkClass
        The example above is used to remove a work class named CustomWorkClass for a service policy in the generic server cluster identified through the ODR name.
        
        Example 2, wsadmin -lang jython -f workclassoperations.py -deletewc -wctype ARP -appname A -wcname CustomWorkClass
        The example above is used to remove a work class named CustomWorkClass for a routing policy in the enterprise application called A.

    """
    java.lang.System.exit(1)      
def showHelp():    
     print """
        DESCRIPTION
            This command is used to create or update work classes for a deployed application and/or generic server cluster, list rules in a work class, get default action defined in a work class, delete rule in a work class, add URI to a work class web module, modify URIs, list URIs, or remove work classes. 
            Each invocation can only create one work class; either for routing policy or for service policy. To create a set of work classes for enterprise application and generic server cluster, the command must be executed at least twice. While some options like -wctype and -wcname are required for all command invocations, others are required based on the combination of options and the intended operation. The examples below will aid you in knowing the required options for each operation.
            In general, when the command usage is displayed because of incorrect or incomplete input options, the cause of failure will be printed on top of the usage message, so scroll up to find out specific error messages. Also, in the examples, certain characters have been escaped to prevent the command-line processor from interpreting them as special charaters. In such cases, there may be variations based on the operating system. For example, on Windows, to escape the percent sign (%), the character sequence (\%%) is used while on Unix type operating systems, to escape the percent sign, the escape sequence is (\%).
            
        Usage: wsadmin 
                       [-lang jython]
                       [-f workclassoperations.py]
                       [-odrname odrName]
                       [-odrnode odrNode]
                       [-wcname workClassName]
                       [-appname appName]
                       [-webmodule webModule]
                       [-addmember ["member1?member2?..."]]
                       [-type HTTP|SOAP]
                       [-vhost virtualHost]
                       [-wctype APP|GSC|ARP|ASP|GRP|GSP]
                       [-addrule ["priority?expr?actiontype?action"]]
                       [-deleterule [priority]]
                       [-deletemember ["member1?member2?..."]]
                       [-deletewc]
                       [-listrule]
                       [-listmembers]
                       [-setdefaultaction ["actiontype?action"]]
                       [-modifydefaultaction ["actiontype?action"]]
                       [-getdefaultaction]
                       [-systemapp]
                       [-both]
        
        EXAMPLES
           Example 1: wsadmin -lang jython -f workclassoperations.py -appname A -wcname CustomWorkClass -type HTTP -wctype APP -webmodule myWebModule -addmember "/test1?/test2/*" -addrule "1?clienthost=\'localhost\' and serverhost like \'\%%.ibm.com\'?permit" -setdefaultaction "reject?404"
           The example above is used to create enterprise application work class for routing policy. It has the default action of reject with a reject code of 404 and priority of 2. If issuing the command above on Unix base operating system, the escape sequence (\%%) should be replaced by (\%).
           
           Example 2: wsadmin -lang jython -f workclassoperations.py -appname A -wcname Custom2WorkClass -type HTTP -wctype APP -webmodule myWebModule -setdefaultaction "Default_TC" -addmember "/test1?/test2/*" -addrule "1?clienthost=\'localhost\' and serverhost like \'\%%.ibm.com\'?Default_TC"
           The example above is used to create enterprise application work class for service policy. If issuing the command above on Unix base operating system, the escape sequence (\%%) should be replaced by (\%).
           
           Example 3: wsadmin -lang jython -f workclassoperations.py -odrname ODR -odrnode myNode01 -wcname GSCWorkClass  -vhost default_host -wctype GSC -setdefaultaction "permit?myGSC"
           The example above is used to create work class for routing policy with a default type of HTTP. Its default action rule has a priority of 0, and action type of permit, and an action of the generic server cluster name for that requests are routed to.
        
           Example 4: wsadmin -lang jython -f workclassoperations.py -odrname ODR -odrnode myNode01 -wcname GSCWorkClass -vhost default_host -wctype GSC -addrule "1?serverhost=\'localhost\' and serverhost like \'\%%.ibm.com\'?TransactionClassA" -setdefaultaction "TransactionClassB"
           The example above is used to create work class for the service policy with a default type of HTTP. If issuing the command above on Unix base operating system, the escape sequence (\%%) should be replaced by (\%).
        
           Example 5: wsadmin -lang jython -f workclassoperations.py -deleterule 1 -wcname CustomWorkClass -both -appname A -wctype APP"
           The example above is used to delete a rule with priority 1 in work class named CustomWorkClass for both (-both option) routing and service policies.
           
           Example 6: wsadmin -lang jython -f workclassoperations.py -listrule -wcname CustomWorkClass -both -appname A -wctype APP"
           The example above is used to list rules in work class named CustomWorkClass for both (-both option) routing and service policies for the enterprise application A.
           
           Example 7: wsadmin -lang jython -f workclassoperations.py -listrule -wcname CustomWorkClass -both -odrname ODR -odrnode theTestNode01 -wctype GSC"
           The example above is used to list rules in work class named CustomWorkClass for both (-both option) routing and service policies for the generic server cluster.
           
           Example 8: wsadmin -lang jython -f workclassoperations.py -getdefaultaction -wcname CustomWorkClass -both -appname A -wctype APP"
           The example above is used to get default actions in work class named CustomWorkClass for both (-both option) routing and service policies.
           
           Example 9: wsadmin -lang jython -f workclassoperations.py -deletewc -wcname CustomWorkClass -appname A -wctype ARP"
           The example above is used to delete a routing policy work class named CustomWorkClass under the enterprise application A.
           
           Example 10: wsadmin -lang jython -f workclassoperations.py -deletewc -wcname CustomWorkClass -appname A -wctype ASP"
           The example above is used to delete a service policy work class named CustomWorkClass under the enterprise application A edition.
           
           Example 11: wsadmin -lang jython -f workclassoperations.py -deletewc -wcname CustomWorkClass -odrname myODR -wctype GSP"
           The example above is used to delete a service policy work class named CustomWorkClass under the ODR named myODR.
           
           Example 12: wsadmin -lang jython -f workclassoperations.py -deletewc -wcname CustomWorkClass -odrname myODR -wctype GRP"
           The example above is used to delete a routing policy work class named CustomWorkClass under the ODR named myODR.
           
           Example 13: wsadmin -lang jython -f workclassoperations.py -listmembers -wcname CustomWorkClass -appname A -webmodule microwebapp"
           The example above is used to list URIs in work class named CustomWorkClass for application A and web module microwebapp.
           
           Example 14: wsadmin -lang jython -f workclassoperations.py -deletemember "/myURI/help.jsp" -wcname CustomWorkClass -appname A -webmodule microwebapp"
           The example above is used to delete URIs in work class named CustomWorkClass for application A and web module microwebapp. Use the -wctype ARP or ASP to distinquish between routing and service policies work class. If -wctype is not used, the routing policy work class is used.
           
           Example 15: wsadmin -lang jython -f workclassoperations.py -appname A -webmodule microwebapp -wcname Custom2WorkClass -wctype APP -type HTTP -addmember "/test1?/test2/*" -setdefaultaction "redirect?http://www.ibm.com" -addrule "1?clienthost=\'localhost\' and serverhost like \'\%%.ibm.com\'?permit?A"  -addrule "2?protocol IN (\'HTTP\',\'HTTPS\')?permitsticky?A"
           The example above is used to create enterprise application work class for routing policy with two additional rules and the default. If issuing the command above on Unix base operating system, the escape sequence (\%%) should be replaced by (\%).
           
           Example 16: wsadmin -lang jython -f workclassoperations.py -addmember "/myURI/help.jsp" -wcname CustomWorkClass -appname A -webmodule microwebapp -wctype ARP"
           The example above is used to add URIs to an existing work class named CustomWorkClass for application A and web module microwebapp. Use the -wctype ARP or ASP to distinquish between routing and service policies work class.
           
           Example 17: wsadmin -lang jython -f workclassoperations.py -appname A -wcname CustomWorkClass -type SOAP -wctype APP -webmodule myWebModule -addmember "RemoteTest:addJob?RemoteTest:removeJob" -addrule "1?clienthost=\'localhost\' and serverhost like \'\%%.ibm.com\'?permit" -setdefaultaction "reject?404"
           The example above is used to create enterprise application SOAP work class for routing policy. It has the default action of reject with a reject code of 404 and priority of 2. If issuing the command above on Unix base operating system, the escape sequence (\%%) should be replaced by (\%).
           
        COMMAND LINE OPTIONS
        -addrule is used to add or define rules for the created work class. It cannot be used with the -deleterule, -listrule, or -getdefaultaction options on the same command invocation. If adding more than one rule at a time, list them in the order of their priority starting from a low number to the higher number in sequence.
                 'priority' is the priority assigned to the rule being created, it takes on integer value, for example, 0, 1, 2, 3, etc., with 0 being the highest priority.
                 the question mark (?) is a separator and it is required in this sequence.
                 'expr' is the rule expression as documented in the WebSphere Extended Deployment documentation.
                 'actiontype' is the type of action to be taken and has an enumerated values of permit, permitsticky, reject, or redirect. If creating an service policy work class, the actiontype is the transaction class name.
                 'action' its value depends on the actiontype. For example, if actiontype is 'redirect' then the action will be the redirect URL. For example, redirect?http://www.ibm.com. For actiontype of reject,
                 the action will be a reject code. For example, reject?404. For generic server cluster work classes, the action is the name of the generic server cluster.  
        -appname appName is used to specify the name of the enterprise application without the .ear extension.
        -addmember is used to provide a collection of member patterns to associate with the work class web module for the enterprise application. Member patterns are separated by the (?) sign and each member pattern must start with a forward slash (/).
                For SOAP work classes, the format must be "<webService>:<operationName>?<webSerivce>:<operationName>".  This example is for two entries.
                   For IIOP work classes, the format must be "<ejbName>:<ejbMethod>?<ejbName>:<ejbMethod>".  This example is for two entries.
                   For JMS work classes, the format must be "<bus>:<destination>?<bust>:<destination>".  This example is for two entries.                   
        -both is used to indicate that the -listrule, -deleterule, or the -getdefaultaction operation should be applied for both routing and service policies on the given work class name.
        -deleterule is used to delete a specific rule from the work class specified using the -wcname option. It cannot be used with the -addrule, -listrule, or -getdefaultaction options on the same command invocation.
        -deletemember is used to provide a collection of URI patterns to be deleted from the web module's work class. This option is applicable to only enterprise application work classes.
        -listmembers is used to display URI from the web module element of the work class. This option is applicable to only enterprise application work classes.
        -deletewc is used to delete a work class. The -wctype with a value of either ARP, ASP, GRP, GSP must also be specified along with this option.
        -getdefaultaction gets the default actiontype and action defined in the work class specified using the -wcname option. It cannot be used with -addrule, -delete, or -listrule options on the same command invocation.
        -listrule displays the rules defined in the work class. It cannot be used with -addrule, -deleterule, or -getdefaultaction options on the same command invocation.
        -modifydefaultaction uses the actiontype and action specified to modify the default action for the existing work class specified using the -wcname option.
        -odrname odrName is used to specify the name of your On Demand Router (ODR) proxy server.
        -odrnode odrNode is used to specify the name of your ODR node.
        -setdefaultaction uses the actiontype and action specified to create a rule with the expression denoted by the asterisk (*) sign and sets the action type and action to the values provided with the option.
        -systemapp is used to indicate that the application is a system application
        -type HTTP   if the -type option is not specified, then the default of HTTP will be assumed.
        -vhost virtualHost  is used to specify the name of the virtual host for the generic server cluster.
        -webmodule webModule  is the web module name without the .war extension.
        -wcname workClassName is used to specify the name of the workclass, no spaces are allowed in the work class name. This option is required.
        -wctype takes a constant value of either APP for enterprise application or GSC for generic server cluster. If the -deletewc option is specified, then acceptable values are ARP for delete application routing work class, ASP for delete application service policy work class, GRP for delete generic server cluster routing policy work class, and GSP for delete generic server service policy work class. There is no default, so a value must be specified.

     """
     errorExit()
#
#
#  main() - 
#
wasinstallroot=System.getProperty("was.install.root")
execfile(wasinstallroot+"/bin/XDPYModules.py")

if (len(sys.argv) < 5):
   showHelp()
global myOdrName,myWorkClassName,myOdrNode,myVirtualHost,myActionType,myTCName,myAppName,myRule,myWebModule,myURIS,myDeleteURIS,isPerformBoth,isAppWorkClasses,isListRule,isGetDefaultAction,isModifyDefaultAction,isSystemApp,myEJBName,patternOverlaps
myWhatToCreate=0
isPerformBoth=0
isListRule=0
isListURI=0
isGetDefaultAction=0
isModifyDefaultAction=0
isDeleteWorkClass=0
isDeleteURI=0
isSystemApp=0
myProtocolType=""
myOdrName=""
myWorkClassName=""
myOdrNode=""
myVirtualHost=""
myActionType=""
myTCName=""
myAppName=""
myWebModule=""
myAction=""
myExpression=""
myWorkClassType=""
myDefaultAction=""
myDeleteURIS=""
myURIS=""
myEJBName=""
patternOverlaps=""
myDeleteRulePriority=-1
count=0
myRule=jarray.zeros(9,java.lang.String)
# myWhatToCreate=1: Routing; myWhatToCreate=2:Service Policy; Both:3
for i in range(0,len(sys.argv),1): 
  option = sys.argv[i]
  if (option == "-odrname"):
      myOdrName = sys.argv[i+1].rstrip()
  elif (option == "-odrnode"):
      myOdrNode = sys.argv[i+1].rstrip()
  elif (option == "-wcname"):
      myWorkClassName = sys.argv[i+1].rstrip()
  elif (option == "-ejbName"):
      myEJBName = sys.argv[i+1].rstrip()      
  elif (option == "-deletewc"):
      isDeleteWorkClass = 1
  elif (option == "-systemapp"):
      isSystemApp = 1
  elif (option == "-type"):
      myProtocolType = sys.argv[i+1].rstrip()
  elif (option == "-vhost"):
      myVirtualHost = sys.argv[i+1].rstrip()
  elif (option == "-both"):
      isPerformBoth = 1
  elif (option == "-appname" ):
      myAppName = sys.argv[i+1].rstrip()
  elif (option == "-webmodule"):
      myWebModule = sys.argv[i+1].rstrip()
  elif (option == "-addmember" or option == "-adduri"):
      myURIS = sys.argv[i+1].rstrip()
  elif (option == "-deletemember" or option == "-deleteuri"):
      myDeleteURIS = sys.argv[i+1].rstrip()
      isDeleteURI = 1
  elif (option == "-wctype"):
      myWorkClassType = sys.argv[i+1].rstrip()
      if (myWorkClassType == "APP" or myWorkClassType == "ARP" or myWorkClassType == "ASP" ):
           isAppWorkClasses=1
      else:
           isAppWorkClasses=0
  elif (option == "-listrule"):
      isListRule = 1
  elif (option == "-listmembers" or option == "-listuri"):
      isListURI = 1
  elif (option == "-getdefaultaction"):
      isGetDefaultAction = 1
  elif (option == "-deleterule"):
      myDeleteRulePriority = sys.argv[i+1].rstrip()
      if (not(myDeleteRulePriority.isdigit())):
          print ""
          print "You have specified -deleterule option without passing in a valid priority, priority must be a digit."
  elif (option == "-setdefaultaction"):
      myDefaultAction = sys.argv[i+1].rstrip()
      if (len(myDefaultAction.split("?")) < 1):
          print ""
          print "You have specified -setdefaultaction option without passing in the required arguments."
  elif (option == "-modifydefaultaction"):
      myDefaultAction = sys.argv[i+1].rstrip()
      isModifyDefaultAction = 1
      if (len(myDefaultAction.split("?")) < 1):
          print ""
          print "You have specified -modifydefaultaction option without passing in the required arguments."
  elif (option == "-addrule"):
      myRule[count] = sys.argv[i+1].rstrip().replace("\\","")
      if (len(myRule[count].split("?")) < 3):
          print ""
          print "You have specified -addrule option without passing in the required arguments."
      count = count + 1
      
if(myProtocolType == ""):
     myProtocolType = "HTTP"     

#
# Find out what the caller is trying to do and check to make
# sure they've got the correct options to do what they want
#
if (not (myAppName == "")):
    if ( isSystemApp == 0 and AppTypeDeploymentTask.isLongRunningApp(myAppName)):
        print ""
        print "INFO: Invalid command."
        print "INFO: Long Running Applications do not have scripting support.  No processing was done, goodbye!"
        errorExit()       

#TODO --
# Haven't tested this out yet.
# Also, make sure zos autoFVT for this script is not effected
#
cellName = AdminConfig.showAttribute(AdminConfig.list("Cell"),"name")    
if (myProtocolType == "IIOP" or myProtocolType == "JMS"):
    if (ApplicationUtil.isAppDeployedOnZOS(myAppName, cellName)):
        print ""
        print "INFO: Invalid command."
        print "INFO: "+myProtocolType+" work classes are not supported on this platform at this time.  No processing was done, goodbye!"
        errorExit()        
        
    if (myWorkClassType != "ASP"):
        print ""
        print "INFO: Invalid command."        
        print "INFO: "+myProtocolType+" work classes of "+myWorkClassType+" type are not supported at this time.  No processing was done, goodbye!"
        errorExit()

if (myProtocolType == "JMS"):    
    if (ApplicationUtil.isEJBModule(myAppName, myWebModule+".jar", cellName)):
        if (myEJBName == ""):
            print ""
            print "INFO: Invalid command."
            print "INFO: When specifying an ejb module for a JMS workclass please specify an EJB with the -ejbName parameter."
            errorExit()  
    else:
        if (not(myEJBName == "")):
            print ""
            print "INFO: Invalid command."
            print "INFO: The -ejbName parameter is reserved for JMS work classes and ejb jar modules."
            errorExit()

if (myProtocolType != "HTTP"):
    if (myURIS != ""):
        #matchExpression is not empty so validate
        matchExpression = ""
        valid = "false"
        for match in myURIS.split("?"):
            matchExpression = match
            name = matchExpression.split(":")
            if len(name) == 2:
                valid = "true"
            else:
                valid = "false"
                if (myProtocolType == "SOAP" and match == "*"):
                    valid = "true"
    else:
        #empty matchExpression is valid
        valid = "true"
        
    if valid == "false":
        print ""
        print "INFO: Invalid command."
        
        exampleURIs = "";
        if (myProtocolType == "SOAP"):
            exampleURIs = "<webService>:<operationName>?<webSerivce>:<operationName>"
        elif (myProtocolType == "IIOP"):
            exampleURIs = "<ejbName>:<ejbMethod>?<ejbName>:<ejbMethod>"
        else:
            exampleURIs = "<bus>:<destination>?<bus>:<destination>"
            
        print "INFO: For "+myProtocolType+" work classes, the format needs to be '"+exampleURIs+"' ."
        errorExit()       
    
if (myURIS != ""):
    for match in myURIS.split("?"):
        if (isMatchOverlapping(match) == "true"):
            print ""
            print "INFO: Invalid command."
            print "INFO: the match pattern '"+match+"' has already been mapped for this Enterprise Application/Module."
            errorExit()          
      
if (isDeleteWorkClass == 1 and myWorkClassType == "ARP"):
    if (myAppName == "" or myWorkClassName == ""):
        showRemoveWCHelp()
    checkForReservedWC()
    removeAppRoutingWorkClass(myWorkClassName, myAppName)
elif (isDeleteWorkClass == 1 and myWorkClassType == "ASP"):
    if (myAppName == "" or myWorkClassName == ""):
        showRemoveWCHelp()
    checkForReservedWC()
    removeAppSLAWorkClass(myWorkClassName, myAppName)
elif (isDeleteWorkClass == 1 and myWorkClassType == "GRP"):
   if (myOdrName == "" or myWorkClassName == ""):
        showRemoveWCHelp()
   checkForReservedWC()
   removeGSCRoutingWorkClass(myWorkClassName, myOdrName)    
elif (isDeleteWorkClass == 1 and myWorkClassType == "GSP"):
   if (myOdrName == "" or myWorkClassName == ""):
        showRemoveWCHelp()
   checkForReservedWC()
   removeGSCSLAWorkClass(myWorkClassName, myOdrName)
elif (isSystemApp == 1 and isModifyDefaultAction):
   processSystemAppRequest() 
elif (isDeleteURI == 1):
   if (myDeleteURIS == "" or myDeleteURIS.startswith("-")):
        print ""
        print "You have specified -deletemember option without passing in the required argument."
   isAppWorkClasses=1
   removeWorkClassURI()
elif (isListURI == 1):
    isAppWorkClasses=1
    listHTTPWorkClassURI()
    normalExit()    
elif (isListRule == 1):
    processRulesForWorkClass()
    normalExit()
elif (isGetDefaultAction == 1):
    processRulesForWorkClass()
    normalExit()
elif (myDeleteRulePriority != -1):
    deleteWorkClassRule()
    normalExit()
elif (isAppWorkClasses ==1 and (myRule[0] != None or myDefaultAction != "")):
    # process app workclasses
    processAppWorkClassRequest()
elif (isAppWorkClasses == 0 and (myRule[0] != None or myDefaultAction != "")):
    # process GSC workclass
    processGSCWorkClassRequest()
elif (myURIS != "" and (myWorkClassType == "ARP" or myWorkClassType == "ASP")):
    processAppWorkClassRequest()
else:
    print ""
    print "INFO: Invalid command."    
    print "INFO: You have not supplied valid options, no processing was done, goodbye!"
    
print "Saving workspace"
AdminConfig.save()
print "finished."